%------------ UNIVERSIDAD NACIONAL AUTNOMA DE MXICO ------------
%------------ FACULTAD DE ESTUDIOS SUPERIORES ARAGN  ------------
%---------------------- INGENIERA CIVIL -------------------------
%------------- PROGRAMA PARA EL CLCULO DE ARMADURAS -------------
clc  
clear all
close all

disp("------------- PROGRAMA PARA EL CLCULO DE ARMADURAS -------------")
est = questdlg('SELECCIONA EL TIPO DE ARMADURA', ...
	'Armaduras', ...
	'Armadura Plana','Armadura Tridimensional','Armadura Plana');

       datos_ar={'Nmero de barras','Nmero de nodos: ',...
       'Nmero de desplazamientos desconocidos',...
       'Nmero de fuerzas conocidas','Escala grfica'};
       titulo='Ingrese los datos de la armadura';
       dims=[1 54];
       definput={'','','','',''};
       answer=inputdlg(datos_ar,titulo,dims,definput);

       b=str2num(answer{1});
       No=str2num(answer{2});
       d=str2num(answer{3});
       m=str2num(answer{4});
       eg=str2num(answer{5});
       
switch est
    case 'Armadura Plana'
        GL=2*No;
        
        %IMPORTAR DATOS DE LA ESTRUCTURA DESDE EXCEL
        archivo='Armaduras.xlsx'; %<<---- Nombre del archivo 
        CGCNPB=xlsread(archivo,-1);
        
        fprintf('\n\n LA TABLA DE COORDENADAS Y PROPIEDADES ES\n\n')
        CGCNPB;

        Ele=1:1:b;
        Elemento=Ele';
        Nx=CGCNPB(:,1);
        Ny=CGCNPB(:,2);
        Fx=CGCNPB(:,3);
        Fy=CGCNPB(:,4);
        Cnx=CGCNPB(:,5);
        Cny=CGCNPB(:,6);
        Cfx=CGCNPB(:,7);
        Cfy=CGCNPB(:,8);
        E=CGCNPB(:,9);
        A=CGCNPB(:,10);

        Datos=table(Elemento,Nx,Ny,Fx,Fy,Cnx,Cny,Cfx,Cfy,E,A)
        
disp("-----------------------------------------------------------------")

%CLCULO DE LA MATRIZ DE RIGIDEZ PARA CADA BARRA Y MATRIZ GLOBAL
for i=1:b   
    
    %COORDENADAS DE LOS NODOS DE LA BARRA 
    Dxf=CGCNPB(i,7);
    Dxn=CGCNPB(i,5);
    Dyf=CGCNPB(i,8);
    Dyn=CGCNPB(i,6);
    
    %PROPIEDADES DE LA BARRA
    L=sqrt((Dxf-Dxn)^2+(Dyf-Dyn)^2);
    A=CGCNPB(i,10);
    E=CGCNPB(i,9);
    
    %COSENOS DIRECTORES
    lx=(Dxf-Dxn)/L;
    ly=(Dyf-Dyn)/L;

    f1=[lx^2,lx*ly,-lx^2,-lx*ly];
    f2=[lx*ly,ly^2,-lx*ly,-ly^2];
    f3=[-lx^2,-lx*ly,lx^2,lx*ly];
    f4=[-lx*ly,-ly^2,lx*ly,ly^2];
    
    %MATRIZ DE RIGIDEZ DE LA BARRA
    k(:,:,i)=A*E/L*[f1;f2;f3;f4];
    
    %COORDENADAS GLOBALES DE LA MATRIZ
    nx=CGCNPB(i,1);
    ny=CGCNPB(i,2);
    fx=CGCNPB(i,3);
    fy=CGCNPB(i,4);

    %ENSAMBLE DE LA MATRIZ DE RIGIDEZ GLOBAL 
    K(nx,nx,i)=k(1,1,i);
    K(nx,ny,i)=k(1,2,i);
    K(nx,fx,i)=k(1,3,i);
    K(nx,fy,i)=k(1,4,i);

    K(ny,nx,i)=k(2,1,i);
    K(ny,ny,i)=k(2,2,i);
    K(ny,fx,i)=k(2,3,i);
    K(ny,fy,i)=k(2,4,i);

    K(fx,nx,i)=k(3,1,i);
    K(fx,ny,i)=k(3,2,i);
    K(fx,fx,i)=k(3,3,i);
    K(fx,fy,i)=k(3,4,i);

    K(fy,nx,i)=k(4,1,i);
    K(fy,ny,i)=k(4,2,i);
    K(fy,fx,i)=k(4,3,i);
    K(fy,fy,i)=k(4,4,i);
    
    fprintf('\nMATRIZ DE RIGIDEZ BARRA %i',i)
    k(:,:,i)
end

fprintf('\n\n LA MATRIZ GLOBAL DE RIGIDEZ ES:\n')

K0=sum(K,3)
       
disp("-----------------------------------------------------------------")

%PARTICIN DE LA MATRIZ DE RIGIDEZ
fprintf('\n\n MATRIZ K11\n')
MK11=K0(1:d,1:d)

fprintf('\n\n MATRIZ K12\n')
MK12=K0(1:d,d+1:end)

fprintf('\n\n MATRIZ K21\n')
MK21=K0(d+1:end,1:d)

fprintf('\n\n MATRIZ K22\n')
MK22=K0(d+1:end,d+1:end)

disp("-----------------------------------------------------------------")

%INTRODUCIR LAS FUERZAS QUE ACTAN SOBRE LA ARMADURA
fprintf("\n\n FUERZAS CONOCIDAS \n")

Qk=zeros(d,1);
for i=1:m
    h=input('\n\nGL donde se aplica la fuerza: ');
    Qk(h,1)=input('Ingrese el valor de la fuerza: ');
end

%VECTOR DE FUERZAS CONOCIDAS
Qk;

disp("-----------------------------------------------------------------")

%INTRODUCIR LOS DESPLAZAMIENTOS CONOCIDOS
fprintf("\n\n DESPLAZAMIENTOS CONOCIDOS \n\n")

for x=d+1:GL
    for j=1
        disp(['Direccion del GL (',num2str(x),')'])
        Dk(x,j)=input(' ');    
    end 
end

%VECTOR DE DESPLAZAMIENTOS CONOCIDOS
Dk1=Dk(d+1:end,end);

%CLCULO DE LOS DESPLAZAMIENTOS DESCONOCIDOS
VD=(MK11^-1)*(Qk-MK12*Dk1);  

%CLCULO DE LAS REACCIONES EN LOS APOYOS
R=(MK21)*VD+(MK22)*Dk1; 

%CONCATENACIN DE LOS DESPLAZAMIENTOS DESCONOCIDOS Y CONOCIDOS
vd=[VD;Dk1];

%CLCULO DE LAS FUERZAS EN LAS BARRAS
for i=1:b
    Dxf=CGCNPB(i,7);
    Dxn=CGCNPB(i,5);
    Dyf=CGCNPB(i,8);
    Dyn=CGCNPB(i,6);
    
    nx=CGCNPB(i,1);
    ny=CGCNPB(i,2);
    fx=CGCNPB(i,3);
    fy=CGCNPB(i,4);

    A=CGCNPB(i,10);
    E=CGCNPB(i,9);
    L=sqrt((Dxf-Dxn)^2+(Dyf-Dyn)^2);
    
    ef(1,1)=-(Dxf-Dxn)/L;
    ef(1,2)=-(Dyf-Dyn)/L;
    ef(1,3)=(Dxf-Dxn)/L;
    ef(1,4)=(Dyf-Dyn)/L;
    
    qf(i,1)=((E*A)/L)*ef*[vd(nx,1);vd(ny,1);vd(fx,1);vd(fy,1)];
end

%-----------------------GRFICA ARMADURA-----------------------------
figure (1)
hold on
est=CGCNPB(:,5:8);
est=reshape(est',1,4,b);
coomod=zeros(2,2);

for i=1:b
    coomod(1,1,i)=est(1,1,i);
    coomod(1,2,i)=est(1,2,i);
    coomod(2,1,i)=est(1,3,i);
    coomod(2,2,i)=est(1,4,i);
end

for i=1:b
    plot(coomod(:,1,i),coomod(:,2,i),'-ok','LineWidth',2,...
       'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
end

%-----------------------GRFICA DEFORMADA-----------------------------
coodesp=zeros(2,2);

for i=1:b
    coodesp(1,1,i)=coomod(1,1,i)+(vd(CGCNPB(i,1),1))*eg;
    coodesp(1,2,i)=coomod(1,2,i)+(vd(CGCNPB(i,2),1))*eg;
    coodesp(2,1,i)=coomod(2,1,i)+(vd(CGCNPB(i,3),1))*eg;
    coodesp(2,2,i)=coomod(2,2,i)+(vd(CGCNPB(i,4),1))*eg;
end

for i=1:b 
    plot(coodesp(:,1,i),coodesp(:,2,i),'-o','color',[0.8 0 0.2],...
    'LineWidth',1,'MarkerSize',7,'MarkerEdgeColor',[0.8 0 0.2],...
    'MarkerFaceColor',[1 0.6 0.6])
end
title(['Armadura & Deformada, eg = ' num2str(eg)])
legend('Armadura sin deformar')
hold off

%------------------------FUERZAS BARRAS------------------------------
figure (2)
hold on
medio=zeros(1,2,b);

for i=1:b
    medio(1,1,i)=((coomod(2,1,i)-coomod(1,1,i))/3)+coomod(1,1,i); %para x/3
    medio(1,2,i)=((coomod(2,2,i)-coomod(1,2,i))/3)+coomod(1,2,i); %para y/3
end
 
 for i=1:b
    fuerza = round(qf(i,1),2);
    
    if fuerza > 0
        plot(coomod(:,1,i),coomod(:,2,i),'-ob','LineWidth',1.3,...
       'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
   
        plot(medio(:,1,i),medio(:,2,i),'ob','MarkerSize',5,...
        'MarkerFaceColor',[0 0 1])
        
        text(medio(:,1,i),medio(:,2,i)-0.05,[' \leftarrow','qf',...
        num2str(i),' = ',num2str(fuerza)],'color','blue','FontSize',8,...
        'FontWeight','normal')
    
    elseif fuerza < 0
        plot(coomod(:,1,i),coomod(:,2,i),'-or','LineWidth',1.3,...
       'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
   
        plot(medio(:,1,i),medio(:,2,i),'or','MarkerSize',5,...
        'MarkerFaceColor',[1 0 0])
        
        text(medio(:,1,i),medio(:,2,i)-0.05,[' \leftarrow','qf',...
        num2str(i),' = ',num2str(fuerza)],'color','red','FontSize',8,...
        'FontWeight','normal')
    
    elseif fuerza ==0
        plot(coomod(:,1,i),coomod(:,2,i),'-ok','LineWidth',1.3,...
        'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
   
        plot(medio(:,1,i),medio(:,2,i),'ok','MarkerSize',5,...
        'MarkerFaceColor',[0 0 0])
        
        text(medio(:,1,i),medio(:,2,i)-0.05,[' \leftarrow','qf',...
        num2str(i),' = ',num2str(fuerza)],'color','black','FontSize',8,...
        'FontWeight','normal')
    end
 end
 
%------------------------ REACCIONES ------------------------------
nodos=[Nx Cnx Cny; Ny Cnx Cny; Fx Cfx Cfy; Fy Cfx Cfy];
GLxnodo=unique(nodos,'rows');
idGL=reshape(GLxnodo',1,3,GL);
nR=(d+1:GL)';   %Grados de libertad correspondientes a las reacciones 
                                       % de la armadura
for i=1:length(nR)
    modulo=mod(idGL(1,1,nR(i,1)),2);
    
    if modulo==1
        text(idGL(1,2,nR(i,1)),idGL(1,3,nR(i,1)),[' \leftarrow',...
        'RGL',num2str(idGL(1,1,nR(i,1))),' = ',num2str(R(i,1))],'color',...
        [0 0 0],'FontSize',9,'FontWeight','bold')
    
    elseif modulo==0
        text(idGL(1,2,nR(i,1)),idGL(1,3,nR(i,1))-0.09*2,[' \leftarrow',...
        'RGL',num2str(idGL(1,1,nR(i,1))),' = ',num2str(R(i,1))],'color',...
        [0 0 0],'FontSize',9,'FontWeight','bold')
    end
end
title('Fuerzas Barras & Reacciones')
hold off

%------------------------ DESPLAZAMIENTOS ------------------------------
figure (3)
hold on
Cnx1=zeros(b,1);
Cny1=zeros(b,1);
Cfx1=zeros(b,1);
Cfy1=zeros(b,1);

for i=1:b
    Cnx1(i,1)=CGCNPB(i,5)+(vd(CGCNPB(i,1),1))*(eg);
    Cny1(i,1)=CGCNPB(i,6)+(vd(CGCNPB(i,2),1))*(eg);
    Cfx1(i,1)=CGCNPB(i,7)+(vd(CGCNPB(i,3),1))*(eg);
    Cfy1(i,1)=CGCNPB(i,8)+(vd(CGCNPB(i,4),1))*(eg);
end
cdes=[Cnx1 Cny1 Cfx1 Cfy1];

  if b <= 10
     des=0.12;
  else
     des=0.17;
  end
 
  for i=1:b
      plot(coodesp(:,1,i),coodesp(:,2,i),'-o','color',[0.8 0 0.2],...
      'LineWidth',1.3,'MarkerSize',7,'MarkerEdgeColor',[0.8 0 0.2],...
      'MarkerFaceColor',[1 0.6 0.6])
    
      xd=vd(CGCNPB(i,1),1);
      yd=vd(CGCNPB(i,2),1);
      xd1=vd(CGCNPB(i,3),1);
      yd1=vd(CGCNPB(i,4),1);
      
      text(cdes(i,1),cdes(i,2),[' \leftarrow',' x = ',num2str(xd)],...
          'color','black','FontSize',8)
    
      text(cdes(i,1),cdes(i,2)-des,['      y = ',num2str(yd)],...
          'color','black','FontSize',8)
    
      text(cdes(i,3),cdes(i,4),[' \leftarrow',' x = ',num2str(xd1)],...
          'color','black','FontSize',8)
    
      text(cdes(i,3),cdes(i,4)-des,['      y = ',num2str(yd1)],...
         'color','black','FontSize',8) 
  end
title(['Desplazamientos Nodos, eg = ' num2str(eg)])
hold off

    case 'Armadura Tridimensional'
        GL=3*No;
        
        %IMPORTAR DATOS DE LA ESTRUCTURA DESDE EXCEL
        archivo='Armaduras.xlsx'; %<<---- Nombre del archivo 
        CGCNPB=xlsread(archivo,-1);
        
        fprintf('\n\n LA TABLA DE COORDENADAS Y PROPIEDADES ES\n\n')
        CGCNPB;

        Ele=1:1:b;
        Elemento=Ele';
        Nx=CGCNPB(:,1);
        Ny=CGCNPB(:,2);
        Nz=CGCNPB(:,3);
        Fx=CGCNPB(:,4);
        Fy=CGCNPB(:,5);
        Fz=CGCNPB(:,6);
        Cnx=CGCNPB(:,7);
        Cny=CGCNPB(:,8);
        Cnz=CGCNPB(:,9);
        Cfx=CGCNPB(:,10);
        Cfy=CGCNPB(:,11);
        Cfz=CGCNPB(:,12);
        E=CGCNPB(:,13);
        A=CGCNPB(:,14);

        Datos=table(Elemento,Nx,Ny,Nz,Fx,Fy,Fz,Cnx,Cny,Cnz,Cfx,Cfy,Cfz,E,A)

disp("-----------------------------------------------------------------")

%CLCULO DE LA MATRIZ DE RIGIDEZ PARA CADA BARRA MATRIZ GLOBAL
for i=1:b
    
    %COORDENADAS DE LOS NUDOS DE LA BARRA
    Dxf=CGCNPB(i,10);
    Dxn=CGCNPB(i,7);
    Dyf=CGCNPB(i,11);
    Dyn=CGCNPB(i,8);
    Dzf=CGCNPB(i,12);
    Dzn=CGCNPB(i,9);
    
    %PROPIEDADES DE LA BARRA
    L=sqrt((Dxf-Dxn)^2+(Dyf-Dyn)^2+(Dzf-Dzn)^2);
    A=CGCNPB(i,14);
    E=CGCNPB(i,13);
    
    %COSENOS DIRECTORES
    lx=(Dxf-Dxn)/L;
    ly=(Dyf-Dyn)/L;
    lz=(Dzf-Dzn)/L;
    
    f1=[lx^2,lx*ly,lx*lz,-lx^2,-lx*ly,-lx*lz];
    f2=[ly*lx,ly^2,ly*lz,-ly*lx,-ly^2,-ly*lz];
    f3=[lz*lx,lz*ly,lz^2,-lz*lx,-lz*ly,-lz^2];
    f4=[-lx^2,-lx*ly,-lx*lz,lx^2,lx*ly,lx*lz];
    f5=[-ly*lx,-ly^2,-ly*lz,ly*lx,ly^2,ly*lz];
    f6=[-lz*lx,-lz*ly,-lz^2,lz*lx,lz*ly,lz^2];
    
    %MATRIZ DE RIGIDEZ DE LA BARRA
    k(:,:,i)=A*E/L*[f1;f2;f3;f4;f5;f6];
    
    %COORDENADAS GLOBALES DE LA MATRIZ
    nx=CGCNPB(i,1);
    ny=CGCNPB(i,2);
    nz=CGCNPB(i,3);
    fx=CGCNPB(i,4);
    fy=CGCNPB(i,5);
    fz=CGCNPB(i,6);
    
    %ENSAMBLE DE LA MATRIZ DE RIGIDEZ GLOBAL
    K(nx,nx,i)=k(1,1,i);
    K(nx,ny,i)=k(1,2,i);
    K(nx,nz,i)=k(1,3,i);
    K(nx,fx,i)=k(1,4,i);
    K(nx,fy,i)=k(1,5,i);
    K(nx,fz,i)=k(1,6,i);
    
    K(ny,nx,i)=k(2,1,i);
    K(ny,ny,i)=k(2,2,i);
    K(ny,nz,i)=k(2,3,i);
    K(ny,fx,i)=k(2,4,i);
    K(ny,fy,i)=k(2,5,i);
    K(ny,fz,i)=k(2,6,i);
    
    K(nz,nx,i)=k(3,1,i);
    K(nz,ny,i)=k(3,2,i);
    K(nz,nz,i)=k(3,3,i);
    K(nz,fx,i)=k(3,4,i);
    K(nz,fy,i)=k(3,5,i);
    K(nz,fz,i)=k(3,6,i);
    
    K(fx,nx,i)=k(4,1,i);
    K(fx,ny,i)=k(4,2,i);
    K(fx,nz,i)=k(4,3,i);
    K(fx,fx,i)=k(4,4,i);
    K(fx,fy,i)=k(4,5,i);
    K(fx,fz,i)=k(4,6,i);
    
    K(fy,nx,i)=k(5,1,i);
    K(fy,ny,i)=k(5,2,i);
    K(fy,nz,i)=k(5,3,i);
    K(fy,fx,i)=k(5,4,i);
    K(fy,fy,i)=k(5,5,i);
    K(fy,fz,i)=k(5,6,i);
    
    K(fz,nx,i)=k(6,1,i);
    K(fz,ny,i)=k(6,2,i);
    K(fz,nz,i)=k(6,3,i);
    K(fz,fx,i)=k(6,4,i);
    K(fz,fy,i)=k(6,5,i);
    K(fz,fz,i)=k(6,6,i);
    
    fprintf('\nMATRIZ DE RIGIDEZ BARRA %i',i)
    k(:,:,i)
end

fprintf('\n\n LA MATRIZ GLOBAL DE RIGIDEZ ES:\n')

K0=sum(K,3) 
 
disp("-----------------------------------------------------------------")

%PARTICIN DE LA MATRIZ DE RIGIDEZ
fprintf('\n\n MATRIZ K11\n')
MK11=K0(1:d,1:d)

fprintf('\n\n MATRIZ K12\n')
MK12=K0(1:d,d+1:end)

fprintf('\n\n MATRIZ K21\n')
MK21=K0(d+1:end,1:d)

fprintf('\n\n MATRIZ K22\n')
MK22=K0(d+1:end,d+1:end)

disp("-----------------------------------------------------------------")

%INTRODUCIR LAS FUERZAS QUE ACTAN SOBRE LA ARMADURA
fprintf("\n\n FUERZAS CONOCIDAS \n")

Qk=zeros(d,1);
for i=1:m
    h=input('\n\nGL donde se aplica la fuerza: ');
    Qk(h,1)=input('Ingrese el valor de la fuerza: ');
end

%VECTOR DE FUERZAS CONOCIDAS
Qk;

disp("-----------------------------------------------------------------")

%INTRODUCIR LOS DESPLAZAMIENTOS CONOCIDOS
fprintf("\n\n DESPLAZAMIENTOS CONOCIDOS \n\n")

for x=d+1:GL
    for j=1
        disp(['Direccion del GL (',num2str(x),')'])
        Dk(x,j)=input(' ');    
    end 
end

%VECTOR DE DESPLAZAMIENTOS CONOCIDOS
Dk1=Dk(d+1:end,end);

%CLCULO DE LOS DESPLAZAMIENTOS DESCONOCIDOS
VD=(MK11^-1)*(Qk-MK12*Dk1);

%CLCULO DE LAS REACCIONES EN LOS APOYOS
R=(MK21)*VD+(MK22)*Dk1;

%CONCATENACIN DE LOS DESPLAZAMIENTOS DESCONOCIDOS Y CONOCIDOS
vd=[VD;Dk1];

%CLCULO DE LAS FUERZAS EN LAS BARRAS
for i=1:b
    Dxf=CGCNPB(i,10);
    Dxn=CGCNPB(i,7);
    Dyf=CGCNPB(i,11);
    Dyn=CGCNPB(i,8);
    Dzf=CGCNPB(i,12);
    Dzn=CGCNPB(i,9);
    
    nx=CGCNPB(i,1);
    ny=CGCNPB(i,2);
    nz=CGCNPB(i,3);
    fx=CGCNPB(i,4);
    fy=CGCNPB(i,5);
    fz=CGCNPB(i,6);

    A=CGCNPB(i,14);
    E=CGCNPB(i,13);
    L=sqrt((Dxf-Dxn)^2+(Dyf-Dyn)^2+(Dzf-Dzn)^2);
    
    ef(1,1)=-(Dxf-Dxn)/L;
    ef(1,2)=-(Dyf-Dyn)/L;
    ef(1,3)=-(Dzf-Dzn)/L;
    ef(1,4)=(Dxf-Dxn)/L;
    ef(1,5)=(Dyf-Dyn)/L;
    ef(1,6)=(Dzf-Dzn)/L;
    
    qf(i,1)=((E*A)/L)*ef*[vd(nx,1);vd(ny,1);vd(nz,1);vd(fx,1);vd(fy,1);...
              vd(fz,1)];   
end

%-----------------------GRFICA ARMADURA-----------------------------
figure (1)
hold on
est=CGCNPB(:,7:12);
est=reshape(est',1,6,b);
coomod=zeros(2,3);

for i=1:b
    coomod(1,1,i)=est(1,1,i);
    coomod(1,2,i)=est(1,2,i);
    coomod(1,3,i)=est(1,3,i);
    coomod(2,1,i)=est(1,4,i);
    coomod(2,2,i)=est(1,5,i);
    coomod(2,3,i)=est(1,6,i);
end

for i=1:b
           %para x         para y         para z
    plot3(-coomod(:,1,i),-coomod(:,2,i),coomod(:,3,i),'-ok','LineWidth',...
    2,'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
end

%-----------------------GRFICA DEFORMADA-----------------------------
coodesp=zeros(2,3);

for i=1:b
    coodesp(1,1,i)=coomod(1,1,i)+(vd(CGCNPB(i,1),1))*eg;
    coodesp(1,2,i)=coomod(1,2,i)+(vd(CGCNPB(i,2),1))*eg;
    coodesp(1,3,i)=coomod(1,3,i)+(vd(CGCNPB(i,3),1))*eg;
    coodesp(2,1,i)=coomod(2,1,i)+(vd(CGCNPB(i,4),1))*eg;
    coodesp(2,2,i)=coomod(2,2,i)+(vd(CGCNPB(i,5),1))*eg;
    coodesp(2,3,i)=coomod(2,3,i)+(vd(CGCNPB(i,6),1))*eg;
end

for i=1:b 
           %para x         para y          para z
    plot3(-coodesp(:,1,i),-coodesp(:,2,i),coodesp(:,3,i),'-o',...
    'color',[0.8 0 0.2],'LineWidth',1,'MarkerSize',7,'MarkerEdgeColor',...
    [0.8 0 0.2],'MarkerFaceColor',[1 0.6 0.6])
end
title(['Armadura & Deformada 3D, eg = ' num2str(eg)])
legend('Armadura sin deformar')
hold off

%------------------------FUERZAS BARRAS------------------------------
figure (2)
hold on
medio=zeros(1,3,b);

for i=1:b
    medio(1,1,i)=((coomod(2,1,i)-coomod(1,1,i))/3)+coomod(1,1,i); %para x/3
    medio(1,2,i)=((coomod(2,2,i)-coomod(1,2,i))/3)+coomod(1,2,i); %para y/3
    medio(1,3,i)=((coomod(2,3,i)-coomod(1,3,i))/3)+coomod(1,3,i); %para Z/3
end
 
 for i=1:b
    fuerza=qf(i,1);
    
    if fuerza > 0
        plot3(-coomod(:,1,i),-coomod(:,2,i),coomod(:,3,i),'-ob',...
        'LineWidth',1.3,'MarkerSize',7,'MarkerEdgeColor','k',...
        'MarkerFaceColor',[.49 1 .63])
   
        plot3(-medio(:,1,i),-medio(:,2,i),medio(:,3,i),'ob',...
        'MarkerSize',5,'MarkerFaceColor',[0 0 1])
        
        text(-medio(:,1,i),-medio(:,2,i),medio(:,3,i),...
        [' \leftarrow','qf',num2str(i),' = ',num2str(fuerza)],...
        'color','blue','FontSize',8,'FontWeight','normal')
    
    elseif fuerza < 0
        plot3(-coomod(:,1,i),-coomod(:,2,i),coomod(:,3,i),'-or',...
        'LineWidth',1.3,'MarkerSize',7,'MarkerEdgeColor','k',...
        'MarkerFaceColor',[.49 1 .63])
   
        plot3(-medio(:,1,i),-medio(:,2,i),medio(:,3,i),'or',...
        'MarkerSize',5,'MarkerFaceColor',[1 0 0])
        
        text(-medio(:,1,i),-medio(:,2,i),medio(:,3,i),...
        [' \leftarrow','qf',num2str(i),' = ',num2str(fuerza)],...
        'color','red','FontSize',8,'FontWeight','normal')
    
    elseif fuerza ==0
        plot3(-coomod(:,1,i),-coomod(:,2,i),coomod(:,3,i),'-ok',...
        'LineWidth',1.3,'MarkerSize',7,'MarkerEdgeColor',...
        'k','MarkerFaceColor',[.49 1 .63])
   
        plot3(-medio(:,1,i),-medio(:,2,i),medio(:,3,i),'ok',...
        'MarkerSize',5,'MarkerFaceColor',[0 0 0])
        
        text(-medio(:,1,i),-medio(:,2,i),medio(:,3,i),...
        [' \leftarrow','qf',num2str(i),' = ',num2str(fuerza)],...
        'color','black','FontSize',8,'FontWeight','normal')
    end
 end

%------------------------ REACCIONES ------------------------------
nodos=[Nx Cnx Cny Cnz; Ny Cnx Cny Cnz; Nz Cnx Cny Cnz; Fx Cfx Cfy Cfz;...
       Fy Cfx Cfy Cfz; Fz Cfx Cfy Cfz];
GLxnodo=unique(nodos,'rows');
XYZ=1:3;                                      
S=repmat(XYZ',GL/3,1);
GLxnodo=[S GLxnodo];
idGL=reshape(GLxnodo',1,5,GL);
nR=(d+1:GL)';   

for i=1:length(nR)
    modulo=idGL(1,1,nR(i,1));
    
    if modulo==1
        text(-idGL(1,3,nR(i,1)),-idGL(1,4,nR(i,1)),idGL(1,5,nR(i,1)),...
        [' \leftarrow','RGL',num2str(idGL(1,2,nR(i,1))),' = ',...
        num2str(R(i,1))],'color',[0 0 0],'FontSize',9,'FontWeight','bold')
    
    elseif modulo==2
        text(-idGL(1,3,nR(i,1)),-idGL(1,4,nR(i,1)),...
        idGL(1,5,nR(i,1))-0.09*2,[' \leftarrow','RGL',...
        num2str(idGL(1,2,nR(i,1))),' = ',num2str(R(i,1))],...
        'color',[0 0 0],'FontSize',9,'FontWeight','bold')
    
    elseif modulo==3
        text(-idGL(1,3,nR(i,1)),-idGL(1,4,nR(i,1)),...
        idGL(1,5,nR(i,1))-0.09*4,[' \leftarrow','RGL',...
        num2str(idGL(1,2,nR(i,1))),' = ',num2str(R(i,1))],...
        'color',[0 0 0],'FontSize',9,'FontWeight','bold')
    end
end
title('Fuerzas Barras & Reacciones')
hold off

%------------------------ DESPLAZAMIENTOS ------------------------------
figure (3)
hold on
Cnx1=zeros(b,1);
Cny1=zeros(b,1);
Cnz1=zeros(b,1);
Cfx1=zeros(b,1);
Cfy1=zeros(b,1);
Cfz1=zeros(b,1);

for i=1:b
    Cnx1(i,1)=CGCNPB(i,7)+(vd(CGCNPB(i,1),1))*(eg);
    Cny1(i,1)=CGCNPB(i,8)+(vd(CGCNPB(i,2),1))*(eg);
    Cnz1(i,1)=CGCNPB(i,9)+(vd(CGCNPB(i,3),1))*(eg);
    
    Cfx1(i,1)=CGCNPB(i,10)+(vd(CGCNPB(i,4),1))*(eg);
    Cfy1(i,1)=CGCNPB(i,11)+(vd(CGCNPB(i,5),1))*(eg);
    Cfz1(i,1)=CGCNPB(i,12)+(vd(CGCNPB(i,6),1))*(eg);
end
cdes=[Cnx1 Cny1 Cnz1 Cfx1 Cfy1 Cfz1];

if b <= 10
     des=0.25;
else
     des=0.30; 
end

  for i=1:b
    hold  on
           %para x         para y          para z
    plot3(-coodesp(:,1,i),-coodesp(:,2,i),coodesp(:,3,i),'-o',...
    'color',[0.8 0 0.2],'LineWidth',1,'MarkerSize',7,'MarkerEdgeColor',...
    [0.8 0 0.2],'MarkerFaceColor',[1 0.6 0.6])
    
    xd=vd(CGCNPB(i,1),1);
    yd=vd(CGCNPB(i,2),1);
    zd=vd(CGCNPB(i,3),1);
    xd1=vd(CGCNPB(i,4),1);
    yd1=vd(CGCNPB(i,5),1);
    zd1=vd(CGCNPB(i,6),1);
            
    text(-cdes(i,1),-cdes(i,2),cdes(i,3),[' \leftarrow',' x = ',...
        num2str(xd)],'color','black','FontSize',8)
   
    text(-cdes(i,1),-cdes(i,2),cdes(i,3)-des,...
        ['      y = ',num2str(yd)],'color','black','FontSize',8)
    
    text(-cdes(i,1),-cdes(i,2),cdes(i,3)-des*2.2,...
        ['      z = ',num2str(zd)],'color','black','FontSize',8)
    
    text(-cdes(i,4),-cdes(i,5),cdes(i,6),[' \leftarrow',' x = ',...
        num2str(xd1)],'color','black','FontSize',8)
    
    text(-cdes(i,4),-cdes(i,5),cdes(i,6)-des,...
        ['      y = ',num2str(yd1)],'color','black','FontSize',8)
    
    text(-cdes(i,4),-cdes(i,5),cdes(i,6)-des*2.2,...
        ['      z = ',num2str(zd1)],'color','black','FontSize',8) 
  end
title(['Desplazamientos Nodos, eg = ' num2str(eg)])
hold off
end

fprintf('\n**********************RESULTADOS****************************\n')
fprintf('\n<-------------------DESPLAZAMIENTOS------------------------>\n')
fprintf('\n\tGL\t\t Desplazamientos\n\n');
for i=1:GL 
if vd(i,1)<0
    fprintf('\t%g\t\t \b%.4f\n',[i;vd(i,1)'])
else 
    fprintf('\t%g\t\t %.4f\n',[i;vd(i,1)']) 
end
end

disp("<----------------------REACCIONES---------------------------->")
fprintf('\n\tGL\t\t Reacciones\n\n');
j=d+1:GL;
for i=1:(GL-d)   
if R(i,1)<0
    fprintf('\t%g\t\t \b%.4f\n',[j(1,i);(R(i,1))'])
else
    fprintf('\t%g\t\t %.4f\n',[j(1,i);(R(i,1))']) 
end
end

disp("<------------------------BARRAS------------------------------>")
fprintf('\n\tBarra\t Fuerza\n\n');
for i=1:b 
if qf(i,1)<0
    fprintf('\t%g\t\t \b%.4f\n',[i;(qf(i,1))'])
else 
    fprintf('\t%g\t\t %.4f\n',[i;(qf(i,1))'])
end
end