function varargout = ArmadurasGUI(varargin)
% ARMADURASGUI MATLAB code for ArmadurasGUI.fig
%      ARMADURASGUI, by itself, creates a new ARMADURASGUI or raises the existing
%      singleton*.
%
%      H = ARMADURASGUI returns the handle to a new ARMADURASGUI or the handle to
%      the existing singleton*.
%
%      ARMADURASGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ARMADURASGUI.M with the given input arguments.
%
%      ARMADURASGUI('Property','Value',...) creates a new ARMADURASGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ArmadurasGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ArmadurasGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ArmadurasGUI

% Last Modified by GUIDE v2.5 07-Mar-2021 00:23:55

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ArmadurasGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @ArmadurasGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ArmadurasGUI is made visible.
function ArmadurasGUI_OpeningFcn(hObject, ~, handles, varargin)
clc
set(handles.Ar3D,'Value',0)
set(handles.Ar2D,'Value',0)
set(handles.Nonodos,'String',1)
set(handles.Nobarras,'String',1)
set(handles.GArmDef,'Value',0)
set(handles.GFuerzas1,'Value',0)
set(handles.GDesplazamientos1,'Value',0)
set(handles.uitoolbar1,'visible','off')
set(handles.slider1,'Min',0,'Max',100)
set(handles.slider1,'Value',0.001)
min=num2str(get(handles.slider1,'Min'));
max=num2str(get(handles.slider1,'Max'));
handles.eg=get(handles.slider1,'Value');
set(handles.Minimo,'String',min)
set(handles.Maximo,'String',max)
set(handles.Valor,'String',num2str(handles.eg))
set(handles.DefAsentamientos,'Value',0);
% Choose default command line output for ArmadurasGUI
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = ArmadurasGUI_OutputFcn(~, ~, handles) 

varargout{1} = handles.output;

% --- Executes when selected object is changed in TipoEstructura.
function TipoEstructura_SelectionChangedFcn(hObject, ~, handles)
handles.Estructura=get(hObject,'Tag');
set(handles.DefAsentamientos,'Value',0);

No=str2double(get(handles.Nonodos,'String'));
b=str2double(get(handles.Nobarras,'String'));
set(handles.Nonodos,'String',No,'enable','on')
set(handles.Nobarras,'String',b,'enable','on')

if strcmp(handles.Estructura,'Ar2D')==1
    
    set(handles.A,'Data',cell(No,10),'ColumnEditable',true,'ColumnName',...
        {'Nodo','Coordenada x','Coordenada y','Fuerza x','Fuerza y',...
        'Restriccion x','Restriccion y','Angulo Nodal','Kx','Ky'},'ColumnFormat',...
        repelem({'numeric'},10))
    
    set(handles.B,'Data',cell(b,6),'ColumnEditable',true,'ColumnName',...
        {'Barra','Nodo N','Nodo F','E','A','dL','alpha','dT'},'ColumnFormat',repelem({'numeric'},8))

elseif strcmp(handles.Estructura,'Ar3D')==1
   
    set(handles.A,'Data',cell(No,10),'ColumnEditable',true,'ColumnName',...
        {'Nodo','Coordenada x','Coordenada y','Coordenada z',...
        'Fuerza x','Fuerza y','Fuerza z','Restriccion x',...
        'Restriccion y','Restriccion z'},'ColumnFormat',repelem({'numeric'},10))
    
    set(handles.B,'Data',cell(b,5),'ColumnEditable',true,'ColumnName',...
        {'Barra','Nodo N','Nodo F','E','A'},'ColumnFormat',repelem({'numeric'},5))
end
set(handles.GArmDef,'Value',1)
guidata(hObject, handles);


function Nonodos_Callback(hObject, ~, handles)
No=str2double(get(hObject,'String'));

if strcmp(handles.Estructura,'Ar2D')==1
    
    set(handles.A,'Data',cell(No,10),'ColumnEditable',true,'ColumnName',...
        {'Nodo','Coordenada x','Coordenada y','Fuerza x','Fuerza y',...
        'Restriccion x','Restriccion y','Angulo Nodal','Kx','Ky'},'ColumnFormat',...
        repelem({'numeric'},10))

elseif strcmp(handles.Estructura,'Ar3D')==1
   
    set(handles.A,'Data',cell(No,10),'ColumnEditable',true,'ColumnName',...
        {'Nodo','Coordenada x','Coordenada y','Coordenada z',...
        'Fuerza x','Fuerza y','Fuerza z','Restriccion x',...
        'Restriccion y','Restriccion z'},'ColumnFormat',repelem({'numeric'},10))
end
guidata(hObject, handles);


function Nobarras_Callback(hObject, ~, handles)
b=str2double(get(hObject,'String'));

if strcmp(handles.Estructura,'Ar2D')==1
    
   set(handles.B,'Data',cell(b,6),'ColumnEditable',true,'ColumnName',...
        {'Barra','Nodo N','Nodo F','E','A','dL','alpha','dT'},'ColumnFormat',repelem({'numeric'},8))

elseif strcmp(handles.Estructura,'Ar3D')==1
   
    set(handles.B,'Data',cell(b,5),'ColumnEditable',true,'ColumnName',...
        {'Barra','Nodo N','Nodo F','E','A'},'ColumnFormat',repelem({'numeric'},5))
end
guidata(hObject, handles);


% --- Executes on button press in DefAsentamientos.
function DefAsentamientos_Callback(hObject, ~, handles)
guidata(hObject, handles);


% --- Executes on button press in Calcular.
function Calcular_Callback(hObject, ~, handles)

NodosDatos=get(handles.A,'Data');
barrasnodos=get(handles.B,'Data');

if iscell(NodosDatos)==1 && iscell(barrasnodos)==1
    
    NodosDatos=cell2mat(get(handles.A,'Data'));
    barrasnodos=cell2mat(get(handles.B,'Data'));
else
    
    NodosDatos=get(handles.A,'Data');
    barrasnodos=get(handles.B,'Data');
end
D=get(handles.DefAsentamientos,'Value');

if strcmp(handles.Estructura,'Ar2D')==1
   
    Restricciones=NodosDatos(:,6:7);
    Fuerzas=NodosDatos(:,4:5);
    b=length(barrasnodos(:,1));
    No=length(NodosDatos(:,1));
    union=barrasnodos(:,2:3);
    Angulo=NodosDatos(:,8);
    kxy=NodosDatos(:,9:10);
    
    % ---------------------------------------------------------------------
    for i=1:No
        if Angulo(i,1)~=0
            
            fx=Fuerzas(i,1)*cosd(360-(Angulo(i,1)))+Fuerzas(i,2)*sind(360-(-Angulo(i,1)));
            fy=Fuerzas(i,1)*sind(360-(Angulo(i,1)))+Fuerzas(i,2)*cosd(360-(-Angulo(i,1)));
            
            Fuerzas(i,1)=fx;
            Fuerzas(i,2)=fy;
        end
    end
    % ---------------------------------------------------------------------
    f=Fuerzas;
    Restricciones=reshape(Restricciones',1,[]);
    Fuerzas=reshape(Fuerzas',[],1);
    kn=reshape(kxy',1,[]);
    E=barrasnodos(:,4);
    A=barrasnodos(:,5);
    difL=barrasnodos(:,6);
    alpha=barrasnodos(:,7);
    difT=barrasnodos(:,8);
    
    % ---------------------------------------------------------------------
    L=zeros(b,1);
    lx=zeros(b,1);
    ly=zeros(b,1);
    lxr=zeros(b,1);
    lyr=zeros(b,1);
    lxr2=zeros(b,1);
    lyr2=zeros(b,1);
    
    k=zeros(4,4,b);
    dL=zeros(4,1,b);
    dT=zeros(4,1,b);
   
    for i=1:b
        
        NN=NodosDatos(union(i,1),2:3);
        NF=NodosDatos(union(i,2),2:3);
        L(i,1)=norm(NF-NN);
        lx(i,1)=(NF(1)-NN(1))/L(i);
        ly(i,1)=(NF(2)-NN(2))/L(i);
        
        if Angulo(union(i,1))==0 && Angulo(union(i,2))==0
            
            k(1,1,i)=(lx(i,1))^2;
            k(1,2,i)=lx(i,1)*ly(i,1);
            k(1,3,i)=-(lx(i,1))^2;
            k(1,4,i)=-lx(i,1)*ly(i,1);
            
            k(2,1,i)=lx(i,1)*ly(i,1);
            k(2,2,i)=(ly(i,1))^2;
            k(2,3,i)=-lx(i,1)*ly(i,1);
            k(2,4,i)=-(ly(i,1))^2;
            
            k(3,1,i)=-(lx(i,1))^2;
            k(3,2,i)=-lx(i,1)*ly(i,1);
            k(3,3,i)=(lx(i,1))^2;
            k(3,4,i)=lx(i,1)*ly(i,1);
            
            k(4,1,i)=-lx(i,1)*ly(i,1);
            k(4,2,i)=-(ly(i,1))^2;
            k(4,3,i)=lx(i,1)*ly(i,1);
            k(4,4,i)=(ly(i,1))^2;
            
            dL(1,1,i)=lx(i,1);
            dL(2,1,i)=ly(i,1);
            dL(3,1,i)=-lx(i,1);
            dL(4,1,i)=-ly(i,1);
            
            dT(1,1,i)=lx(i,1);
            dT(2,1,i)=ly(i,1);
            dT(3,1,i)=-lx(i,1);
            dT(4,1,i)=-ly(i,1);
            
        elseif Angulo(union(i,1))==0 && Angulo(union(i,2))~=0
            
            if (sign(lx(i,1))==1 || sign(lx(i,1))==0) && (sign(ly(i,1))==1 || sign(ly(i,1))==0)
                
                AnguloBarra=acosd(lx(i));
                
                Posicion=AnguloBarra-Angulo(union(i,2));
                
                lxr(i,1)=cosd(Posicion);
                lyr(i,1)=sind(Posicion);
                
            elseif (sign(lx(i,1))==-1 || sign(lx(i,1))==0) && (sign(ly(i,1))==1 || sign(ly(i,1))==0)
                
                AnguloBarra=acosd(lx(i));
                
                Posicion=AnguloBarra-Angulo(union(i,2));
                
                lxr(i,1)=cosd(Posicion);
                lyr(i,1)=sind(Posicion);
                
            elseif (sign(lx(i,1))==-1 || sign(lx(i,1))==0) && (sign(ly(i,1))==-1 || sign(ly(i,1))==0)
                
                if lx(i)==0
                    AnguloBarra=270;
                else
                    AnguloBarra=90+acosd(ly(i));
                end
                
                lxr(i,1)=cosd(360+Angulo(union(i,2))-AnguloBarra);
                lyr(i,1)=cosd(-90-Angulo(union(i,2))+AnguloBarra);
                
            elseif (sign(lx(i,1))==1 || sign(lx(i,1))==0) && (sign(ly(i,1))==-1 || sign(ly(i,1))==0)
                
                if lx(i)==0
                    AnguloBarra=360;
                else
                    AnguloBarra=360-acosd(lx(i));
                end
                
                lxr(i,1)=cosd(360+Angulo(union(i,2))-AnguloBarra);
                lyr(i,1)=cosd(-90-Angulo(union(i,2))+AnguloBarra);
            end
            
            k(1,1,i)=(lx(i,1))^2;
            k(1,2,i)=lx(i,1)*ly(i,1);
            k(1,3,i)=-lx(i,1)*lxr(i,1);
            k(1,4,i)=-lx(i,1)*lyr(i,1);
            
            k(2,1,i)=lx(i,1)*ly(i,1);
            k(2,2,i)=(ly(i,1))^2;
            k(2,3,i)=-lxr(i,1)*ly(i,1);
            k(2,4,i)=-ly(i,1)*lyr(i,1);
            
            k(3,1,i)=-lx(i,1)*lxr(i,1);
            k(3,2,i)=-lxr(i,1)*ly(i,1);
            k(3,3,i)=(lxr(i,1))^2;
            k(3,4,i)=lxr(i,1)*lyr(i,1);
            
            k(4,1,i)=-lx(i,1)*lyr(i,1);
            k(4,2,i)=-ly(i,1)*lyr(i,1);
            k(4,3,i)=lxr(i,1)*lyr(i,1);
            k(4,4,i)=(lyr(i,1))^2;
            
            dL(1,1,i)=lx(i,1);
            dL(2,1,i)=ly(i,1);
            dL(3,1,i)=-lxr(i,1);
            dL(4,1,i)=-lyr(i,1);
            
            dT(1,1,i)=lx(i,1);
            dT(2,1,i)=ly(i,1);
            dT(3,1,i)=-lxr(i,1);
            dT(4,1,i)=-lyr(i,1);
            
        elseif Angulo(union(i,1))~=0 && Angulo(union(i,2))==0
            
             if (sign(lx(i))==0 || sign(lx(i))==1) && (sign(ly(i))==0 || sign(ly(i))==1)
                
                AnguloBarra=acosd(lx(i));
                
                Posicion=AnguloBarra-Angulo(union(i,1));
                
                lxr(i,1)=cosd(Posicion);
                lyr(i,1)=sind(Posicion);
                
            elseif (sign(lx(i))==0 || sign(lx(i))==-1) && (sign(ly(i))==0 || sign(ly(i))==1)
                
                AnguloBarra=acosd(lx(i));
                
                Posicion=AnguloBarra-Angulo(union(i,1));
                
                lxr(i,1)=cosd(Posicion);
                lyr(i,1)=sind(Posicion);
                
            elseif (sign(lx(i,1))==-1 || sign(lx(i,1))==0) && (sign(ly(i,1))==-1 || sign(ly(i,1))==0)
                
                if lx(i)==0
                    AnguloBarra=270;
                else
                    AnguloBarra=90+acosd(ly(i));
                end
                
                lxr(i,1)=cosd(360+Angulo(union(i,1))-AnguloBarra);
                lyr(i,1)=cosd(-90-Angulo(union(i,1))+AnguloBarra);
                
            elseif (sign(lx(i,1))==1 || sign(lx(i,1))==0) && (sign(ly(i,1))==-1 || sign(ly(i,1))==0)
                
                if lx(i)==0
                    AnguloBarra=360;
                else
                    AnguloBarra=360-acosd(lx(i));
                end
                
                lxr(i,1)=cosd(360+Angulo(union(i,1))-AnguloBarra);
                lyr(i,1)=cosd(-90-Angulo(union(i,1))+AnguloBarra);
            end
            
            k(1,1,i)=(lxr(i,1))^2;
            k(1,2,i)=lxr(i,1)*lyr(i,1);
            k(1,3,i)=-lx(i,1)*lxr(i,1);
            k(1,4,i)=-lxr(i,1)*ly(i,1);
            
            k(2,1,i)=lxr(i,1)*lyr(i,1);
            k(2,2,i)=(lyr(i,1))^2;
            k(2,3,i)=-lx(i,1)*lyr(i,1);
            k(2,4,i)=-ly(i,1)*lyr(i,1);
            
            k(3,1,i)=-lx(i,1)*lxr(i,1);
            k(3,2,i)=-lx(i,1)*lyr(i,1);
            k(3,3,i)=(lx(i,1))^2;
            k(3,4,i)=lx(i,1)*ly(i,1);
            
            k(4,1,i)=-lxr(i,1)*ly(i,1);
            k(4,2,i)=-ly(i,1)*lyr(i,1);
            k(4,3,i)=lx(i,1)*ly(i,1);
            k(4,4,i)=(ly(i,1))^2;
            
            dL(1,1,i)=lxr(i,1);
            dL(2,1,i)=lyr(i,1);
            dL(3,1,i)=-lx(i,1);
            dL(4,1,i)=-ly(i,1);
            
            dT(1,1,i)=lxr(i,1);
            dT(2,1,i)=lyr(i,1);
            dT(3,1,i)=-lx(i,1);
            dT(4,1,i)=-ly(i,1);
            
        elseif Angulo(union(i,1))~=0 && Angulo(union(i,2))~=0
            
            if (sign(lx(i))==0 || sign(lx(i))==1) && (sign(ly(i))==0 || sign(ly(i))==1)
                
                AnguloBarra=acosd(lx(i));
                
                Posicion=AnguloBarra-Angulo(union(i,1));
                Posicion2=AnguloBarra-Angulo(union(i,2));
                
                lxr(i,1)=cosd(Posicion);
                lyr(i,1)=sind(Posicion);
                
                lxr2(i,1)=cosd(Posicion2);
                lyr2(i,1)=sind(Posicion2);
                
            elseif (sign(lx(i))==0 || sign(lx(i))==-1) && (sign(ly(i))==0 || sign(ly(i))==1)
                
                AnguloBarra=acosd(lx(i));
                
                Posicion=AnguloBarra-Angulo(union(i,1));
                Posicion2=AnguloBarra-Angulo(union(i,2));
                
                lxr(i,1)=cosd(Posicion);
                lyr(i,1)=sind(Posicion);
                
                lxr2(i,1)=cosd(Posicion2);
                lyr2(i,1)=sind(Posicion2);
                
            elseif (sign(lx(i,1))==-1 || sign(lx(i,1))==0) && (sign(ly(i,1))==-1 || sign(ly(i,1))==0)
                
                if lx(i)==0
                    AnguloBarra=270;
                else
                    AnguloBarra=90+acosd(ly(i));
                end
                
                lxr(i,1)=cosd(360+Angulo(union(i,1))-AnguloBarra);
                lyr(i,1)=cosd(-90-Angulo(union(i,1))+AnguloBarra);
                
                lxr2(i,1)=cosd(360+Angulo(union(i,2))-AnguloBarra);
                lyr2(i,1)=cosd(-90-Angulo(union(i,2))+AnguloBarra);
                
            elseif (sign(lx(i,1))==1 || sign(lx(i,1))==0) && (sign(ly(i,1))==-1 || sign(ly(i,1))==0)
                
                if lx(i)==0
                    AnguloBarra=360;
                else
                    AnguloBarra=360-acosd(lx(i));
                end
                
                lxr(i,1)=cosd(360+Angulo(union(i,1))-AnguloBarra);
                lyr(i,1)=cosd(-90-Angulo(union(i,1))+AnguloBarra);
                
                lxr2(i,1)=cosd(360+Angulo(union(i,2))-AnguloBarra);
                lyr2(i,1)=cosd(-90-Angulo(union(i,2))+AnguloBarra);
            end
            
            k(1,1,i)=(lxr(i,1))^2;
            k(1,2,i)=lxr(i,1)*lyr(i,1);
            k(1,3,i)=-lxr(i,1)*lxr2(i,1);
            k(1,4,i)=-lxr(i,1)*lyr2(i,1);
            
            k(2,1,i)=lxr(i,1)*lyr(i,1);
            k(2,2,i)=(lyr(i,1))^2;
            k(2,3,i)=-lxr2(i,1)*lyr(i,1);
            k(2,4,i)=-lyr(i,1)*lyr2(i,1);
            
            k(3,1,i)=-lxr(i,1)*lxr2(i,1);
            k(3,2,i)=-lxr2(i,1)*lyr(i,1);
            k(3,3,i)=(lxr2(i,1))^2;
            k(3,4,i)=lxr2(i,1)*lyr2(i,1);
            
            k(4,1,i)=-lxr(i,1)*lyr2(i,1);
            k(4,2,i)=-lyr2(i,1)*lyr(i,1);
            k(4,3,i)=lxr2(i,1)*lyr2(i,1);
            k(4,4,i)=(lyr2(i,1))^2;
            
            dL(1,1,i)=lxr(i,1);
            dL(2,1,i)=lyr(i,1);
            dL(3,1,i)=-lxr2(i,1);
            dL(4,1,i)=-lyr2(i,1);
            
            dT(1,1,i)=lxr(i,1);
            dT(2,1,i)=lyr(i,1);
            dT(3,1,i)=-lxr2(i,1);
            dT(4,1,i)=-lyr2(i,1);
            
        end
        
        k(:,:,i)=((E(i)*A(i))/L(i))*k(:,:,i);
        K(:,:,i)=mat2cell(k(:,:,i),[2 2],[2 2]);
        K0(union(i,1),union(i,1),i)=K(1,1,i);
        K0(union(i,1),union(i,2),i)=K(1,2,i);
        K0(union(i,2),union(i,1),i)=K(2,1,i);
        K0(union(i,2),union(i,2),i)=K(2,2,i);
        
        dL(:,:,i)=((E(i)*A(i)*difL(i))/L(i))*dL(:,:,i);
        dL1(:,:,i)=mat2cell(dL(:,:,i),[2 2],1);
        dL0(union(i,1),1,i)=dL1(1,1,i);
        dL0(union(i,2),1,i)=dL1(2,1,i);
        
        dT(:,:,i)=(E(i)*A(i)*alpha(i)*difT(i))*dT(:,:,i);
        dT1(:,:,i)=mat2cell(dT(:,:,i),[2 2],1);
        dT0(union(i,1),1,i)=dT1(1,1,i);
        dT0(union(i,2),1,i)=dT1(2,1,i);
    end

    for z=1:b
        for i=1:No
            for j=1:No
                if size(K0{i,j,z})==[0 0]
                    K0(i,j,z)={zeros(2,2)};
                end
            end
            if size(dL0{i,1,z})==[0 0]
                dL0(i,1,z)={zeros(2,1)};
            end
            if size(dT0{i,1,z})==[0 0]
                dT0(i,1,z)={zeros(2,1)};
            end
        end
        MK0(:,:,z)=cell2mat(K0(:,:,z));
        MdL0(:,:,z)=cell2mat(dL0(:,:,z));
        MdT0(:,:,z)=cell2mat(dT0(:,:,z));
    end
    
    K0=sum(MK0,3);    %Matriz de rigidez global.
    K0=K0+diag(kn);   %Matriz de rigidez global con aporte de las barras mas apoyos elasticos.
    dL0=sum(MdL0,3);  %Matriz de variacion en la longitud.
    dT0=sum(MdT0,3);  %Matriz de variacion por temperatura.
    R0=find(Restricciones==0);
    R1=find(Restricciones==1);
    d=zeros(No*2,1);
    r=zeros(No*2,1);
    
    %MATRIZ K11
    K11=K0;
    K11(R0,:)=[];     %Elimina filas de ceros.
    K11(:,R0)=[];     %Elimina columnas de ceros.
    Fuerzas(R0,:)=[]; %Elimina los ceros del vector de fuerzas donde los
                      %nodos se mantienen restringidos.
    %MATRIZ K12
    K12=K0;
    K12(:,R1)=[];
    K12(R0,:)=[];
    
    %MATRIZ K21
    K21=K0;
    K21(R1,:)=[];
    K21(:,R0)=[];
    
    %MATRIZ K22
    K22=K0;
    K22(R1,:)=[];
    K22(:,R1)=[];
    
    %MATRIZ dL11
    dL11=dL0;
    dL11(R0,:)=[];
    
    %MATRIZ dL22
    dL22=dL0;
    dL22(R1,:)=[];
    
    %MATRIZ dT11
    dT11=dT0;
    dT11(R0,:)=[];
    
    %MATRIZ dT22
    dT22=dT0;
    dT22(R1,:)=[];
    
    % ---------------------------------------------------------------------
    %ASIGNAR DESPLAZAMIENTOS EN ALGUN APOYO

    if D==1
        
        datos_ar={'Nmero de nodos: '};
        titulo='NODOS';
        dims=[1 35];
        definput={''};
        answer=inputdlg(datos_ar,titulo,dims,definput);
        
        NoAsen=str2double(answer{1});
        NodoAsen=zeros(NoAsen,3);
        
        for i=1:NoAsen
            NoMod={'Nodo con desplazamiento:','Desplazamiento en X',...
                'Desplazamiento en Y'};
            titulo='NODO';
            dims=[1 25];
            joints={'Ingrese el nmero de nodo','0','0'};
            answer=inputdlg(NoMod,titulo,dims,joints);
            
            NodoAsen(i,1)=str2double(answer{1});
            NodoAsen(i,2)=str2double(answer{2});
            NodoAsen(i,3)=str2double(answer{3});
        end
        
        asentamientos=NodosDatos(:,6:7);
        
        for i=1:NoAsen
            confix=asentamientos(NodoAsen(i,1),1);
            confiy=asentamientos(NodoAsen(i,1),2);
            
            if confix==0
                asentamientos(NodoAsen(i,1),1)=NodoAsen(i,2);
            end
            
            if confiy==0
                asentamientos(NodoAsen(i,1),2)=NodoAsen(i,3);
            end
        end
        asentamientos=reshape(asentamientos',1,[]);
        asentamientos(:,R1)=[];
    else
        asentamientos=zeros(1,length(R0));
    end
      
    % ---------------------------------------------------------------------

    %CLCULO DE LOS DESPLAZAMIENTOS DESCONOCIDOS
    VD=(K11^-1)*(Fuerzas-K12*asentamientos'-(dL11+dT11));
    
    %ACOMODANDO LOS DESPLAZAMIENTOS "d"
    for i=1:length(R1)
        d(R1(i),1)=VD(i);
    end
    
    for i=1:length(R0)
        d(R0(i),1)=transpose(asentamientos(i));
    end
    df=reshape(d,1,[],No);
    dfrot=df;
    Desprot=reshape(Restricciones,1,2,[]);
    
    for i=1:b
        
        if Angulo(union(i,1))==0 && Angulo(union(i,2))~=0
            
            if Desprot(1,1,union(i,2))==1 && Desprot(1,2,union(i,2))==0 || Desprot(1,1,union(i,2))==0 && Desprot(1,2,union(i,2))==1 || Desprot(1,1,union(i,2))==1 && Desprot(1,2,union(i,2))==1
                dfrot(1,1,union(i,2))=df(1,1,union(i,2))*cosd(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*sind(360-Angulo(union(i,2)));
                dfrot(1,2,union(i,2))=df(1,1,union(i,2))*sind(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*cosd(360-Angulo(union(i,2)));
            end
            
            if Desprot(1,1,union(i,2))==0 && Desprot(1,2,union(i,2))==0
                dfrot(1,1,union(i,2))=df(1,1,union(i,2))*cosd(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*sind(360-Angulo(union(i,2)));
                dfrot(1,2,union(i,2))=df(1,1,union(i,2))*sind(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*cosd(360-Angulo(union(i,2)));
            end
            
        elseif Angulo(union(i,1))~=0 && Angulo(union(i,2))==0
            
            if Desprot(1,1,union(i,1))==1 && Desprot(1,2,union(i,1))==0 || Desprot(1,1,union(i,1))==0 && Desprot(1,2,union(i,1))==1 || Desprot(1,1,union(i,1))==1 && Desprot(1,2,union(i,1))==1
                dfrot(1,1,union(i,1))=df(1,1,union(i,1))*cosd(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*sind(360-Angulo(union(i,1)));
                dfrot(1,2,union(i,1))=df(1,1,union(i,1))*sind(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*cosd(360-Angulo(union(i,1)));
            end
            
            if Desprot(1,1,union(i,1))==0 && Desprot(1,2,union(i,1))==0
                dfrot(1,1,union(i,1))=df(1,1,union(i,1))*cosd(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*sind(360-Angulo(union(i,1)));
                dfrot(1,2,union(i,1))=df(1,1,union(i,1))*sind(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*cosd(360-Angulo(union(i,1)));
            end
            
        elseif Angulo(union(i,1))~=0 && Angulo(union(i,2))~=0
            
            if Desprot(1,1,union(i,2))==1 && Desprot(1,2,union(i,2))==0 || Desprot(1,1,union(i,2))==0 && Desprot(1,2,union(i,2))==1 || Desprot(1,1,union(i,2))==1 && Desprot(1,2,union(i,2))==1
                dfrot(1,1,union(i,2))=df(1,1,union(i,2))*cosd(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*sind(360-Angulo(union(i,2)));
                dfrot(1,2,union(i,2))=df(1,1,union(i,2))*sind(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*cosd(360-Angulo(union(i,2)));
            end
            
            if Desprot(1,1,union(i,1))==1 && Desprot(1,2,union(i,1))==0 || Desprot(1,1,union(i,1))==0 && Desprot(1,2,union(i,1))==1 || Desprot(1,1,union(i,1))==1 && Desprot(1,2,union(i,1))==1
                dfrot(1,1,union(i,1))=df(1,1,union(i,1))*cosd(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*sind(360-Angulo(union(i,1)));
                dfrot(1,2,union(i,1))=df(1,1,union(i,1))*sind(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*cosd(360-Angulo(union(i,1)));
            end
            
            if Desprot(1,1,union(i,2))==0 && Desprot(1,2,union(i,2))==0
                dfrot(1,1,union(i,2))=df(1,1,union(i,2))*cosd(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*sind(360-Angulo(union(i,2)));
                dfrot(1,2,union(i,2))=df(1,1,union(i,2))*sind(Angulo...
                    (union(i,2)))+df(1,2,union(i,2))*cosd(360-Angulo(union(i,2)));
            end
            
            if Desprot(1,1,union(i,1))==0 && Desprot(1,2,union(i,1))==0
                dfrot(1,1,union(i,1))=df(1,1,union(i,1))*cosd(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*sind(360-Angulo(union(i,1)));
                dfrot(1,2,union(i,1))=df(1,1,union(i,1))*sind(Angulo...
                    (union(i,1)))+df(1,2,union(i,1))*cosd(360-Angulo(union(i,1)));
            end
        end
    end
    
    %CLCULO DE LAS REACCIONES EN LOS APOYOS
    R=(K21)*VD+(K22)*asentamientos'+dL22+dT22;
    
    %CLCULO DE LAS REACCIONES EN LOS APOYOS ELASTICOS
    Rkxy=zeros(1,2,No);
    for i=1:No
        Rkxy(1,1,i)=kxy(i,1)*(-df(1,1,i));
        Rkxy(1,2,i)=kxy(i,2)*(-df(1,2,i));
    end

    %ACOMODANDO LAS REACCIONES EN "r"
    for i=1:length(R0)
        r(R0(i),1)=transpose(R(i));
    end
    rf=reshape(r,1,[],No);
    restricciones=NodosDatos(:,6:7);
    
    for i=1:No
        if restricciones(i,1)==1 && restricciones(i,2)==0
            
            if Angulo(i,1)~=0 || Angulo(i,1)==0
                rf(1,2,i)=rf(1,2,i)-f(i,2);
            end
            
        elseif restricciones(i,1)==0 && restricciones(i,2)==0
            if Angulo(i,1)~=0 || Angulo(i,1)==0
                rf(1,1,i)=rf(1,1,i)-f(i,1);
                rf(1,2,i)=rf(1,2,i)-f(i,2);
            end
        end
    end
    
    for i=1:No
        if restricciones(i,1)==1 && restricciones(i,2)==0
            
            rf(1,1,i)=Rkxy(1,1,i);
            
        elseif restricciones(i,1)==0 && restricciones(i,2)==1
            
            rf(1,2,i)=Rkxy(1,2,i);
           
        elseif restricciones(i,1)==1 && restricciones(i,2)==1
            
            rf(1,1,i)=Rkxy(1,1,i);
            rf(1,2,i)=Rkxy(1,2,i);
        end
    end

    %CLCULO DE LAS FUERZAS EN LAS BARRAS
    handles.qf=zeros(b,1);
    for i=1:b
        
        if Angulo(union(i,1))==0 && Angulo(union(i,2))==0
            
            ef=[-lx(i) -ly(i) lx(i) ly(i)];
            handles.qf(i,1)=((E(i)*A(i))/L(i))*(ef*[df(1,1,union(i,1));...
                df(1,2,union(i,1));df(1,1,union(i,2));df(1,2,union(i,2))]-difL(i)-(alpha(i)*difT(i)*L(i)));
            
        elseif Angulo(union(i,1))==0 && Angulo(union(i,2))~=0
            
            ef=[-lx(i) -ly(i) lxr(i) lyr(i)];
            handles.qf(i,1)=((E(i)*A(i))/L(i))*(ef*[df(1,1,union(i,1));...
                df(1,2,union(i,1));df(1,1,union(i,2));df(1,2,union(i,2))]-difL(i)-(alpha(i)*difT(i)*L(i)));
            
        elseif Angulo(union(i,1))~=0 && Angulo(union(i,2))==0
            
            ef=[-lxr(i) -lyr(i) lx(i) ly(i)];
            handles.qf(i,1)=((E(i)*A(i))/L(i))*(ef*[df(1,1,union(i,1));...
                df(1,2,union(i,1));df(1,1,union(i,2));df(1,2,union(i,2))]-difL(i)-(alpha(i)*difT(i)*L(i)));
            
        elseif Angulo(union(i,1))~=0 && Angulo(union(i,2))~=0
            
            ef=[-lxr(i) -lyr(i) lxr2(i) lyr2(i)];
            handles.qf(i,1)=((E(i)*A(i))/L(i))*(ef*[df(1,1,union(i,1));...
                df(1,2,union(i,1));df(1,1,union(i,2));df(1,2,union(i,2))]-difL(i)-(alpha(i)*difT(i)*L(i)));
        end
    end
  
    %-----------------------GRAFICA ARMADURA-----------------------------
    handles.coomod=zeros(2,2,b);
    handles.b=b;
    handles.union=union;
    handles.NodosDatos=NodosDatos;
    
    for i=1:handles.b
        handles.coomod(1,1,i)=handles.NodosDatos(handles.union(i,1),2);
        handles.coomod(1,2,i)=handles.NodosDatos(handles.union(i,1),3);
        handles.coomod(2,1,i)=handles.NodosDatos(handles.union(i,2),2);
        handles.coomod(2,2,i)=handles.NodosDatos(handles.union(i,2),3);
    end
    %-----------------------GRAFICA DEFORMADA-----------------------------
    handles.coodesp=zeros(2,2,b);
    handles.dfrot=dfrot;
    %------------------------FUERZAS BARRAS------------------------------
    handles.medio=zeros(1,2,b);
    for i=1:handles.b
        handles.medio(1,1,i)=((handles.coomod(2,1,i)-handles.coomod(1,1,i))/3)+handles.coomod(1,1,i);
        handles.medio(1,2,i)=((handles.coomod(2,2,i)-handles.coomod(1,2,i))/3)+handles.coomod(1,2,i); 
    end
    %------------------------ REACCIONES ------------------------------
    C=reshape(rf,2,No);
    D=1:No;
    handles.N=[D' C'];
    factor=(zeros(No,1));
    
    for i=1:No
        if handles.N(i,2) ==0 && handles.N(i,3)==0
            factor(i,1)=0;
        else
            factor(i,1)=1;
        end
    end
    handles.N(find(factor==0),:)=[];
    
    %------------------------ DESPLAZAMIENTOS ------------------------------
    handles.Nodosdesp=zeros(No,2);
    handles.df=df;
    handles.No=No;

elseif strcmp(handles.Estructura,'Ar3D')==1

    Restricciones=NodosDatos(:,8:10);
    Restricciones=reshape(Restricciones',1,[]);
    Fuerzas=NodosDatos(:,5:7);
    Fuerzas=reshape(Fuerzas',[],1);
    
    b=length(barrasnodos(:,1));
    No=length(NodosDatos(:,1));
    union=barrasnodos(:,2:3);
    E=barrasnodos(:,4);
    A=barrasnodos(:,5);
    % ---------------------------------------------------------------------
    handles.eg=1;
    % ---------------------------------------------------------------------
    L=zeros(b,1);
    lx=zeros(b,1);
    ly=zeros(b,1);
    lz=zeros(b,1);
    k=zeros(6,6,b);
    
    for i=1:b
        
        NN=NodosDatos(union(i,1),2:4);
        NF=NodosDatos(union(i,2),2:4);
        L(i,1)=norm(NF-NN);
        lx(i,1)=(NF(1)-NN(1))/L(i);
        ly(i,1)=(NF(2)-NN(2))/L(i);
        lz(i,1)=(NF(3)-NN(3))/L(i);
        
        k(1,1,i)=(lx(i,1))^2;
        k(1,2,i)=lx(i,1)*ly(i,1);
        k(1,3,i)=lx(i,1)*lz(i,1);
        k(1,4,i)=-(lx(i,1))^2;
        k(1,5,i)=-lx(i,1)*ly(i,1);
        k(1,6,i)=-lx(i,1)*lz(i,1);
        
        k(2,1,i)=lx(i,1)*ly(i,1);
        k(2,2,i)=(ly(i,1))^2;
        k(2,3,i)=ly(i,1)*lz(i,1);
        k(2,4,i)=-lx(i,1)*ly(i,1);
        k(2,5,i)=-(ly(i,1))^2;
        k(2,6,i)=-ly(i,1)*lz(i,1);
        
        k(3,1,i)=lx(i,1)*lz(i,1);
        k(3,2,i)=ly(i,1)*lz(i,1);
        k(3,3,i)=(lz(i,1))^2;
        k(3,4,i)=-lx(i,1)*lz(i,1);
        k(3,5,i)=-ly(i,1)*lz(i,1);
        k(3,6,i)=-(lz(i,1))^2;
        
        k(4,1,i)=-(lx(i,1))^2;
        k(4,2,i)=-lx(i,1)*ly(i,1);
        k(4,3,i)=-lx(i,1)*lz(i,1);
        k(4,4,i)=(lx(i,1))^2;
        k(4,5,i)=lx(i,1)*ly(i,1);
        k(4,6,i)=lx(i,1)*lz(i,1);
        
        k(5,1,i)=-lx(i,1)*ly(i,1);
        k(5,2,i)=-(ly(i,1))^2;
        k(5,3,i)=-ly(i,1)*lz(i,1);
        k(5,4,i)=lx(i,1)*ly(i,1);
        k(5,5,i)=(ly(i,1))^2;
        k(5,6,i)=ly(i,1)*lz(i,1);
        
        k(6,1,i)=-lx(i,1)*lz(i,1);
        k(6,2,i)=-ly(i,1)*lz(i,1);
        k(6,3,i)=-(lz(i,1))^2;
        k(6,4,i)=lx(i,1)*lz(i,1);
        k(6,5,i)=ly(i,1)*lz(i,1);
        k(6,6,i)=(lz(i,1))^2;
        
        k(:,:,i)=((E(i)*A(i))/L(i))*k(:,:,i);
        
        K(:,:,i)=mat2cell(k(:,:,i),[3 3],[3 3]);
        K0(union(i,1),union(i,1),i)=K(1,1,i);
        K0(union(i,1),union(i,2),i)=K(1,2,i);
        K0(union(i,2),union(i,1),i)=K(2,1,i);
        K0(union(i,2),union(i,2),i)=K(2,2,i);
        
    end
    
    for z=1:b
        for i=1:No
            for j=1:No
                if size(K0{i,j,z})==[0 0]
                    K0(i,j,z)={zeros(3,3)};
                end
            end
        end
        MK0(:,:,z)=cell2mat(K0(:,:,z));
    end
    
    K0=sum(MK0,3);    %Matriz de rigidez global
    R0=find(Restricciones==0);
    R1=find(Restricciones==1);
    
    d=zeros(No*3,1);
    r=zeros(No*3,1);
    
    %MATRIZ K11
    K11=K0;
    K11(R0,:)=[];     %Elimina filas de ceros.
    K11(:,R0)=[];     %Elimina columnas de ceros.
    Fuerzas(R0,:)=[]; %Elimina los ceros del vector de fuerzas donde los nodos
    %se mantienen restringidos.
    %MATRIZ K12
    K12=K0;
    K12(:,R1)=[];
    K12(R0,:)=[];
    
    %MATRIZ K21
    K21=K0;
    K21(R1,:)=[];
    K21(:,R0)=[];
    
    %MATRIZ K22
    K22=K0;
    K22(R1,:)=[];
    K22(:,R1)=[];
    
    % ---------------------------------------------------------------------
    % ASIGNAR DESPLAZAMIENTOS EN ALGUN APOYO
    
    if D==1
        
        datos_ar={'Nmero de nodos: '};
        titulo='NODOS';
        dims=[1 35];
        definput={''};
        answer=inputdlg(datos_ar,titulo,dims,definput);
        
        NoAsen=str2double(answer{1});
        NodoAsen=zeros(NoAsen,4);
        
        for i=1:NoAsen
            NoMod={'Nodo con desplazamiento:','Desplazamiento en X',...
                'Desplazamiento en Y','Desplazamiento en Z'};
            titulo='NODO';
            dims=[1 25];
            joints={'Ingrese el nmero de nodo','0','0','0'};
            answer=inputdlg(NoMod,titulo,dims,joints);
            
            NodoAsen(i,1)=str2double(answer{1});
            NodoAsen(i,2)=str2double(answer{2});
            NodoAsen(i,3)=str2double(answer{3});
            NodoAsen(i,4)=str2double(answer{4});
        end
        
        asentamientos=NodosDatos(:,8:10);
        
        for i=1:NoAsen
            confix=asentamientos(NodoAsen(i,1),1);
            confiy=asentamientos(NodoAsen(i,1),2);
            confiz=asentamientos(NodoAsen(i,1),3);
            
            if confix==0
                asentamientos(NodoAsen(i,1),1)=NodoAsen(i,2);
            end
            
            if confiy==0
                asentamientos(NodoAsen(i,1),2)=NodoAsen(i,3);
            end
            
            if confiz==0
                asentamientos(NodoAsen(i,1),3)=NodoAsen(i,4);
            end
        end
        asentamientos=reshape(asentamientos',1,[]);
        asentamientos(:,R1)=[];
    else
        asentamientos=zeros(1,length(R0));
    end

    % ---------------------------------------------------------------------
    
    %CLCULO DE LOS DESPLAZAMIENTOS DESCONOCIDOS
    VD=(K11^-1)*(Fuerzas-K12*asentamientos');
    
    %ACOMODANDO LOS DESPLAZAMIENTOS EN "d"
    for i=1:length(R1)
        d(R1(i),1)=VD(i);
    end
    
    for i=1:length(R0)
        d(R0(i),1)=transpose(asentamientos(i));
    end
    
    %CLCULO DE LAS REACCIONES EN LOS APOYOS
    R=(K21)*VD+(K22)*asentamientos';
    
    %ACOMODANDO LAS REACCIONES EN "r"
    for i=1:length(R0)
        r(R0(i),1)=transpose(R(i));
    end
    
    %CLCULO DE LAS FUERZAS EN LAS BARRAS
    handles.qf=zeros(b,1);
    df=reshape(d,1,[],No);
    rf=reshape(r,1,[],No);
    
    for i=1:b
        ef=[-lx(i) -ly(i) -lz(i) lx(i) ly(i) lz(i)];
        handles.qf(i,1)=((E(i)*A(i))/L(i))*ef*[df(1,1,union(i,1));...
            df(1,2,union(i,1));df(1,3,union(i,1));df(1,1,union(i,2));...
            df(1,2,union(i,2));df(1,3,union(i,2))];
    end
    
    %-----------------------GRFICA ARMADURA---------------------------
    handles.coomod=zeros(2,3,b);
    handles.b=b;
    handles.union=union;
    handles.NodosDatos=NodosDatos;
    
    for i=1:handles.b
        handles.coomod(1,1,i)=handles.NodosDatos(handles.union(i,1),2);
        handles.coomod(1,2,i)=handles.NodosDatos(handles.union(i,1),3);
        handles.coomod(1,3,i)=handles.NodosDatos(handles.union(i,1),4);
        handles.coomod(2,1,i)=handles.NodosDatos(handles.union(i,2),2);
        handles.coomod(2,2,i)=handles.NodosDatos(handles.union(i,2),3);
        handles.coomod(2,3,i)=handles.NodosDatos(handles.union(i,2),4);
    end
    %-----------------------GRFICA DEFORMADA--------------------------
    handles.coodesp=zeros(2,3,b);
    %------------------------FUERZAS BARRAS----------------------------
    handles.medio=zeros(1,3,b);  
    for i=1:handles.b
        handles.medio(1,1,i)=((handles.coomod(2,1,i)-handles.coomod(1,1,i))/3)+handles.coomod(1,1,i); 
        handles.medio(1,2,i)=((handles.coomod(2,2,i)-handles.coomod(1,2,i))/3)+handles.coomod(1,2,i); 
        handles.medio(1,3,i)=((handles.coomod(2,3,i)-handles.coomod(1,3,i))/3)+handles.coomod(1,3,i); 
    end
    %------------------------ REACCIONES ------------------------------
    C=transpose(reshape(r,[],No));
    D=1:No;
    handles.N=[D' C];
    factor=(zeros(No,1));
    
    for i=1:No
        if handles.N(i,2) ==0 && handles.N(i,3)==0 && handles.N(i,4)==0
            factor(i,1)=0;
        else
            factor(i,1)=1;
        end
    end
    handles.N(find(factor==0),:)=[];
    %------------------------ DESPLAZAMIENTOS -------------------------
    handles.Nodosdesp=zeros(No,3);
    handles.df=df;
    handles.No=No;
end
handles.k=k;
handles.K0=K0;
guidata(hObject, handles);
slider1_Callback(hObject, [], handles);


% --- Executes on button press in GArmDef.
function GArmDef_Callback(hObject, ~, handles)
guidata(hObject, handles);
slider1_Callback(hObject, [], handles);


% --- Executes on button press in GFuerzas1.
function GFuerzas1_Callback(hObject, ~, handles)
guidata(hObject, handles);
set(handles.listbox1,'Value',1)
slider1_Callback(hObject, [], handles);
listbox1_Callback(hObject, [], handles);


% --- Executes on button press in GDesplazamientos1.
function GDesplazamientos1_Callback(hObject, ~, handles)
guidata(hObject, handles);
set(handles.listbox1,'Value',1)
slider1_Callback(hObject, [], handles);
listbox1_Callback(hObject, [], handles);


% --- Executes when selected object is changed in TipoGrafica.
function TipoGrafica_SelectionChangedFcn(hObject, ~, handles)
% handles.Grafica=get(hObject,'Tag');
 guidata(hObject, handles);
 
 
function LimX_Callback(hObject, ~, handles)
limx=str2num(get(hObject,'String'));
set(handles.axes1,'XLim',limx)
guidata(hObject, handles);
slider1_Callback(hObject, [], handles);


function LimY_Callback(hObject, ~, handles)
limy=str2num(get(hObject,'String'));
set(handles.axes1,'YLim',limy)
guidata(hObject, handles);
slider1_Callback(hObject, [], handles);


function LimZ_Callback(hObject, ~, handles)
limz=str2num(get(hObject,'String'));
set(handles.axes1,'ZLim',limz)
guidata(hObject, handles);
slider1_Callback(hObject, [], handles);


function Minimo_Callback(hObject, ~, handles)
min=str2double(get(handles.Minimo,'String'));
set(handles.slider1,'Min',min)
guidata(hObject, handles);


function Maximo_Callback(hObject, ~, handles)
max=str2num(get(hObject,'String'));
set(handles.slider1,'Max',max)
guidata(hObject, handles);


function Valor_Callback(hObject, ~, handles)
v=str2num(get(hObject,'String'));
set(handles.slider1,'Value',v)
guidata(hObject, handles);
slider1_Callback(hObject, [], handles);


% --- Executes on slider movement.
function slider1_Callback(hObject, ~, handles)
handles.eg=get(handles.slider1,'Value');
set(handles.Valor,'String',num2str(handles.eg))
set(handles.axes1,'Box','on','BoxStyle','back','ClippingStyle','rectangle')
% ------------------------------------------------------------------------

gd=get(handles.GArmDef,'Value');
gf=get(handles.GFuerzas1,'Value');
gdes=get(handles.GDesplazamientos1,'Value');

if strcmp(handles.Estructura,'Ar2D')==1

    for i=1:handles.b
        handles.coodesp(1,1,i)=handles.coomod(1,1,i)+handles.dfrot(1,1,handles.union(i,1))*handles.eg;
        handles.coodesp(1,2,i)=handles.coomod(1,2,i)+handles.dfrot(1,2,handles.union(i,1))*handles.eg;
        handles.coodesp(2,1,i)=handles.coomod(2,1,i)+handles.dfrot(1,1,handles.union(i,2))*handles.eg;
        handles.coodesp(2,2,i)=handles.coomod(2,2,i)+handles.dfrot(1,2,handles.union(i,2))*handles.eg;
    end

    for i=1:handles.No
        handles.Nodosdesp(i,1)=handles.NodosDatos(i,2)+handles.dfrot(1,1,i)*handles.eg;
        handles.Nodosdesp(i,2)=handles.NodosDatos(i,3)+handles.dfrot(1,2,i)*handles.eg;
    end
    
    if gd==1
        set(handles.listbox1,'Enable','off')
        hold on
        cla
        for i=1:handles.b
            
            plot(handles.coomod(:,1,i),handles.coomod(:,2,i),'-ok','LineWidth',2,...
                'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
            plot(handles.coodesp(:,1,i),handles.coodesp(:,2,i),'-o','color',[0.8 0 0.2],...
                'LineWidth',1,'MarkerSize',5,'MarkerEdgeColor',[0.8 0 0.2],...
                'MarkerFaceColor',[1 0.6 0.6])
        end
        
        axis equal
        daspect([1 1 1])
        grid on
        hold off
        
    elseif gf==1
        set(handles.listbox1,'Enable','on')
        hold on
        cla
        for i=1:handles.b
            handles.fuerza=round(handles.qf(i,1),2);
            
            if handles.fuerza > 0
                plot(handles.coomod(:,1,i),handles.coomod(:,2,i),'-ob','LineWidth',1.3,...
                    'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
                
                plot(handles.medio(:,1,i),handles.medio(:,2,i),'ob','MarkerSize',5,...
                    'MarkerFaceColor',[0 0 1])
                
                text(handles.medio(:,1,i),handles.medio(:,2,i),[' \leftarrow','qf',...
                    num2str(i),' = ',num2str(handles.fuerza)],'color','blue','FontSize',8,...
                    'FontWeight','normal','VerticalAlignment','bottom')
                
            elseif handles.fuerza < 0
                plot(handles.coomod(:,1,i),handles.coomod(:,2,i),'-or','LineWidth',1.3,...
                    'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
                
                plot(handles.medio(:,1,i),handles.medio(:,2,i),'or','MarkerSize',5,...
                    'MarkerFaceColor',[1 0 0])
                
                text(handles.medio(:,1,i),handles.medio(:,2,i),[' \leftarrow','qf',...
                    num2str(i),' = ',num2str(handles.fuerza)],'color','red','FontSize',8,...
                    'FontWeight','normal','VerticalAlignment','bottom')
                
            elseif handles.fuerza ==0
                plot(handles.coomod(:,1,i),handles.coomod(:,2,i),'-ok','LineWidth',1.3,...
                    'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
                
                plot(handles.medio(:,1,i),handles.medio(:,2,i),'ok','MarkerSize',5,...
                    'MarkerFaceColor',[0 0 0])
                
                text(handles.medio(:,1,i),handles.medio(:,2,i),[' \leftarrow','qf',...
                    num2str(i),' = ',num2str(handles.fuerza)],'color','black','FontSize',8,...
                    'FontWeight','normal','VerticalAlignment','bottom')
            end
        end
        
        for i=1:length(handles.N(:,1))
            text(handles.NodosDatos(handles.N(i,1),2),handles.NodosDatos(handles.N(i,1),3),...
                {['\rightarrowN',num2str(handles.N(i,1))],...
                ['    X= ', num2str(round(handles.N(i,2),4))],...
                ['    Y= ',num2str(round(handles.N(i,3),4))]},...
                'color',[0 0 0],'FontSize',8,'FontWeight','bold','VerticalAlignment','top','Rotation',0)
        end
        
        axis equal
        daspect([1 1 1])
        grid on
        hold off
        
    elseif gdes==1
        set(handles.listbox1,'Enable','on')
        hold on
        cla
        for i=1:handles.b
            plot(handles.coodesp(:,1,i),handles.coodesp(:,2,i),'-o','color',[0.8 0 0.2],...
                'LineWidth',1,'MarkerSize',5,'MarkerEdgeColor',[0.8 0 0.2],...
                'MarkerFaceColor',[1 0.6 0.6])
        end
        
        for i=1:handles.No
            text(handles.Nodosdesp(i,1),handles.Nodosdesp(i,2),[' \rightarrow',...
                'N',num2str(i),' = ',num2str(round(handles.df(1,1,i),4)),' , ',...
                num2str(round(handles.df(1,2,i),4)),],'color',[0 0 0],'FontSize',8,...
                'FontWeight','bold','VerticalAlignment','top')
        end
        
        axis equal
        daspect([1 1 1])
        grid on
        hold off 
    end

elseif strcmp(handles.Estructura,'Ar3D')==1
    
    for i=1:handles.b
        handles.coodesp(1,1,i)=handles.coomod(1,1,i)+handles.df(1,1,handles.union(i,1))*handles.eg;
        handles.coodesp(1,2,i)=handles.coomod(1,2,i)+handles.df(1,2,handles.union(i,1))*handles.eg;
        handles.coodesp(1,3,i)=handles.coomod(1,3,i)+handles.df(1,3,handles.union(i,1))*handles.eg;
        
        handles.coodesp(2,1,i)=handles.coomod(2,1,i)+handles.df(1,1,handles.union(i,2))*handles.eg;
        handles.coodesp(2,2,i)=handles.coomod(2,2,i)+handles.df(1,2,handles.union(i,2))*handles.eg;
        handles.coodesp(2,3,i)=handles.coomod(2,3,i)+handles.df(1,3,handles.union(i,2))*handles.eg;
    end
    
    for i=1:handles.No
        handles.Nodosdesp(i,1)=handles.NodosDatos(i,2)+handles.df(1,1,i)*handles.eg;
        handles.Nodosdesp(i,2)=handles.NodosDatos(i,3)+handles.df(1,2,i)*handles.eg;
        handles.Nodosdesp(i,3)=handles.NodosDatos(i,4)+handles.df(1,3,i)*handles.eg;
    end
    
    if gd==1
        set(handles.listbox1,'Enable','off')
        hold on
        cla 
        for i=1:handles.b
            %para x         para y         para z
            plot3(-handles.coomod(:,1,i),-handles.coomod(:,2,i),handles.coomod(:,3,i),'-ok','LineWidth',...
                2,'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
            
            %para x         para y          para z
            plot3(-handles.coodesp(:,1,i),-handles.coodesp(:,2,i),handles.coodesp(:,3,i),'-o',...
                'color',[0.8 0 0.2],'LineWidth',1,'MarkerSize',5,'MarkerEdgeColor',...
                [0.8 0 0.2],'MarkerFaceColor',[1 0.6 0.6])
        end
        
        daspect([1 1 1])
        grid on
        hold off
        
    elseif gf==1
        set(handles.listbox1,'Enable','on')
        hold on
        cla
        for i=1:handles.b
            handles.fuerza=round(handles.qf(i,1),2);
            
            if handles.fuerza > 0
                plot3(-handles.coomod(:,1,i),-handles.coomod(:,2,i),handles.coomod(:,3,i),'-ob',...
                    'LineWidth',1.3,'MarkerSize',7,'MarkerEdgeColor','k',...
                    'MarkerFaceColor',[.49 1 .63])
                
                plot3(-handles.medio(:,1,i),-handles.medio(:,2,i),handles.medio(:,3,i),'ob',...
                    'MarkerSize',5,'MarkerFaceColor',[0 0 1])
                
                text(-handles.medio(:,1,i),-handles.medio(:,2,i),handles.medio(:,3,i),...
                    [' \leftarrow','qf',num2str(i),' = ',num2str(handles.fuerza)],...
                    'color','blue','FontSize',8,'FontWeight','normal','VerticalAlignment','bottom')
                
            elseif handles.fuerza < 0
                plot3(-handles.coomod(:,1,i),-handles.coomod(:,2,i),handles.coomod(:,3,i),'-or',...
                    'LineWidth',1.3,'MarkerSize',7,'MarkerEdgeColor','k',...
                    'MarkerFaceColor',[.49 1 .63])
                
                plot3(-handles.medio(:,1,i),-handles.medio(:,2,i),handles.medio(:,3,i),'or',...
                    'MarkerSize',5,'MarkerFaceColor',[1 0 0])
                
                text(-handles.medio(:,1,i),-handles.medio(:,2,i),handles.medio(:,3,i),...
                    [' \leftarrow','qf',num2str(i),' = ',num2str(handles.fuerza)],...
                    'color','red','FontSize',8,'FontWeight','normal','VerticalAlignment','bottom')
                
            elseif handles.fuerza ==0
                plot3(-handles.coomod(:,1,i),-handles.coomod(:,2,i),handles.coomod(:,3,i),'-ok',...
                    'LineWidth',1.3,'MarkerSize',7,'MarkerEdgeColor',...
                    'k','MarkerFaceColor',[.49 1 .63])
                
                plot3(-handles.medio(:,1,i),-handles.medio(:,2,i),handles.medio(:,3,i),'ok',...
                    'MarkerSize',5,'MarkerFaceColor',[0 0 0])
                
                text(-handles.medio(:,1,i),-handles.medio(:,2,i),handles.medio(:,3,i),...
                    [' \leftarrow','qf',num2str(i),' = ',num2str(handles.fuerza)],...
                    'color','black','FontSize',8,'FontWeight','normal','VerticalAlignment','bottom')
            end
        end
        
        for i=1:length(handles.N(:,1))
            text(-handles.NodosDatos(handles.N(i,1),2),-handles.NodosDatos(handles.N(i,1),3),...
                handles.NodosDatos(handles.N(i,1),4),[' \rightarrow','N',num2str(handles.N(i,1)),...
                ' = ',num2str(round(handles.N(i,2),4)),' , ',num2str(round(handles.N(i,3),4)),...
                ' , ',num2str(round(handles.N(i,4),4))],'color',[0 0 0],'FontSize',8,...
                'FontWeight','bold','VerticalAlignment','top')
        end
        
        daspect([1 1 1])
        grid on
        hold off
        
    elseif gdes==1
        set(handles.listbox1,'Enable','on')
        hold on
        cla 
        for i=1:handles.b
            %para x         para y          para z
            plot3(-handles.coodesp(:,1,i),-handles.coodesp(:,2,i),handles.coodesp(:,3,i),'-o',...
                'color',[0.8 0 0.2],'LineWidth',1,'MarkerSize',5,'MarkerEdgeColor',...
                [0.8 0 0.2],'MarkerFaceColor',[1 0.6 0.6])
        end
        
        for i=1:handles.No
            text(-handles.Nodosdesp(i,1),-handles.Nodosdesp(i,2),handles.Nodosdesp(i,3),...
                [' \rightarrow','N',num2str(i),' = ',num2str(round(handles.df(1,1,i),...
                4)),' , ',num2str(round(handles.df(1,2,i),4)),' , ',num2str(round(handles.df(1,...
                3,i),4))],'color',[0 0 0],'FontSize',8,'FontWeight','bold',...
                'VerticalAlignment','top')
        end
        
        daspect([1 1 1])
        grid on
        hold off
    end
end
guidata(hObject, handles);


% --- Executes on button press in SDatos.
function SDatos_Callback(hObject, ~, handles)
guidata(hObject, handles);
set(handles.listbox1,'Value',1)
listbox1_Callback(hObject, [], handles);


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, ~, handles)

gd=get(handles.GArmDef,'Value');
gf=get(handles.GFuerzas1,'Value');
gdes=get(handles.GDesplazamientos1,'Value');

if get(handles.SDatos,'Value')==1

    if strcmp(handles.Estructura,'Ar2D')==1
        
        if gd==1
            
            set(handles.listbox1,'Enable','off')
            
        elseif gf==1
            set(handles.listbox1,'Enable','on')
            for i=1:handles.b
                barras{i}=i;
            end
            set(handles.listbox1,'String',barras)
            
            hold on
            cla
            for i=1:handles.b
                
                plot(handles.coomod(:,1,i),handles.coomod(:,2,i),'-o','Color',[0.75 0.75 0.75],'LineWidth',2,...
                    'MarkerSize',7,'MarkerEdgeColor',[0.75 0.75 0.75],'MarkerFaceColor',[0.9 0.9 0.9])
            end
            
            i=get(handles.listbox1,'Value');
            for x=1:length(i)
                handles.fuerza=round(handles.qf(i(x),1),2);
                
                if handles.fuerza > 0
                    plot(handles.coomod(:,1,i(x)),handles.coomod(:,2,i(x)),'-ob','LineWidth',2,...
                        'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
                    
                    plot(handles.medio(:,1,i(x)),handles.medio(:,2,i(x)),'ob','MarkerSize',5,...
                        'MarkerFaceColor',[0 0 1])
                    
                    text(handles.medio(:,1,i(x)),handles.medio(:,2,i(x)),[' \leftarrow','qf',...
                        num2str(i(x)),' = ',num2str(handles.fuerza)],'color','blue','FontSize',10,...
                        'FontWeight','bold','VerticalAlignment','bottom')
                    
                elseif handles.fuerza < 0
                    plot(handles.coomod(:,1,i(x)),handles.coomod(:,2,i(x)),'-or','LineWidth',2,...
                        'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
                    
                    plot(handles.medio(:,1,i(x)),handles.medio(:,2,i(x)),'or','MarkerSize',5,...
                        'MarkerFaceColor',[1 0 0])
                    
                    text(handles.medio(:,1,i(x)),handles.medio(:,2,i(x)),[' \leftarrow','qf',...
                        num2str(i(x)),' = ',num2str(handles.fuerza)],'color','red','FontSize',10,...
                        'FontWeight','bold','VerticalAlignment','bottom')
                    
                elseif handles.fuerza ==0
                    plot(handles.coomod(:,1,i(x)),handles.coomod(:,2,i(x)),'-ok','LineWidth',2,...
                        'MarkerSize',7,'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
                    
                    plot(handles.medio(:,1,i(x)),handles.medio(:,2,i(x)),'ok','MarkerSize',5,...
                        'MarkerFaceColor',[0 0 0])
                    
                    text(handles.medio(:,1,i(x)),handles.medio(:,2,i(x)),[' \leftarrow','qf',...
                        num2str(i(x)),' = ',num2str(handles.fuerza)],'color','black','FontSize',10,...
                        'FontWeight','bold','VerticalAlignment','bottom')
                end
            end
            
            for i=1:length(handles.N(:,1))
            text(handles.NodosDatos(handles.N(i,1),2),handles.NodosDatos(handles.N(i,1),3),...
                {['\rightarrowN',num2str(handles.N(i,1))],...
                ['    X= ', num2str(round(handles.N(i,2),4))],...
                ['    Y= ',num2str(round(handles.N(i,3),4))]},...
                'color',[0 0 0],'FontSize',8,'FontWeight','bold','VerticalAlignment','top','Rotation',0)
            end
            
            daspect([1 1 1])
            axis equal
            grid on
            hold off
            
        elseif gdes==1
            set(handles.listbox1,'Enable','on')
            for i=1:handles.No
                nodos{i}=i;
            end
            set(handles.listbox1,'String',nodos)
            
            hold on
            cla
            for i=1:handles.b
                plot(handles.coodesp(:,1,i),handles.coodesp(:,2,i),'-o','color',[0.8 0 0.2],...
                    'LineWidth',1,'MarkerSize',5,'MarkerEdgeColor',[0.8 0 0.2],...
                    'MarkerFaceColor',[1 0.6 0.6])
            end
            
            i=get(handles.listbox1,'Value');
            for x=1:length(i)
                text(handles.Nodosdesp(i(x),1),handles.Nodosdesp(i(x),2),[' \rightarrow',...
                    'N',num2str(i(x)),' = ',num2str(round(handles.df(1,1,i(x)),4)),' , ',...
                    num2str(round(handles.df(1,2,i(x)),4)),],'color',[0 0 0],'FontSize',8,...
                    'FontWeight','bold','VerticalAlignment','top')
            end
            
            daspect([1 1 1])
            axis equal
            grid on
            hold off 
        end
        
    elseif strcmp(handles.Estructura,'Ar3D')==1
        
        if gd==1
        
            set(handles.listbox1,'Enable','off')
            
        elseif gf==1
            set(handles.listbox1,'Enable','on')
            for i=1:handles.b
                barras{i}=i;
            end
            set(handles.listbox1,'String',barras)
            
            hold on
            cla
            for i=1:handles.b
                %para x         para y         para z
                plot3(-handles.coomod(:,1,i),-handles.coomod(:,2,i),handles.coomod(:,3,i),'-o','Color',[0.75 0.75 0.75],'LineWidth',...
                    2,'MarkerSize',7,'MarkerEdgeColor',[0.75 0.75 0.75],'MarkerFaceColor',[0.9 0.9 0.9])
            end
            
            i=get(handles.listbox1,'Value');
            for x=1:length(i)
                handles.fuerza=round(handles.qf(i(x),1),2);
                
                if handles.fuerza > 0
                    plot3(-handles.coomod(:,1,i(x)),-handles.coomod(:,2,i(x)),handles.coomod(:,3,i(x)),'-ob',...
                        'LineWidth',2,'MarkerSize',7,'MarkerEdgeColor','k',...
                        'MarkerFaceColor',[.49 1 .63])
                    
                    plot3(-handles.medio(:,1,i(x)),-handles.medio(:,2,i(x)),handles.medio(:,3,i(x)),'ob',...
                        'MarkerSize',5,'MarkerFaceColor',[0 0 1])
                    
                    text(-handles.medio(:,1,i(x)),-handles.medio(:,2,i(x)),handles.medio(:,3,i(x)),...
                        [' \leftarrow','qf',num2str(i(x)),' = ',num2str(handles.fuerza)],...
                        'color','blue','FontSize',9,'FontWeight','bold','VerticalAlignment','bottom')
                    
                elseif handles.fuerza < 0
                    plot3(-handles.coomod(:,1,i(x)),-handles.coomod(:,2,i(x)),handles.coomod(:,3,i(x)),'-or',...
                        'LineWidth',2,'MarkerSize',7,'MarkerEdgeColor','k',...
                        'MarkerFaceColor',[.49 1 .63])
                    
                    plot3(-handles.medio(:,1,i(x)),-handles.medio(:,2,i(x)),handles.medio(:,3,i(x)),'or',...
                        'MarkerSize',5,'MarkerFaceColor',[1 0 0])
                    
                    text(-handles.medio(:,1,i(x)),-handles.medio(:,2,i(x)),handles.medio(:,3,i(x)),...
                        [' \leftarrow','qf',num2str(i(x)),' = ',num2str(handles.fuerza)],...
                        'color','red','FontSize',9,'FontWeight','bold','VerticalAlignment','bottom')
                    
                elseif handles.fuerza ==0
                    plot3(-handles.coomod(:,1,i(x)),-handles.coomod(:,2,i(x)),handles.coomod(:,3,i(x)),'-ok',...
                        'LineWidth',2,'MarkerSize',7,'MarkerEdgeColor',...
                        'k','MarkerFaceColor',[.49 1 .63])
                    
                    plot3(-handles.medio(:,1,i(x)),-handles.medio(:,2,i(x)),handles.medio(:,3,i(x)),'ok',...
                        'MarkerSize',5,'MarkerFaceColor',[0 0 0])
                    
                    text(-handles.medio(:,1,i(x)),-handles.medio(:,2,i(x)),handles.medio(:,3,i(x)),...
                        [' \leftarrow','qf',num2str(i(x)),' = ',num2str(handles.fuerza)],...
                        'color','black','FontSize',9,'FontWeight','bold','VerticalAlignment','bottom')
                end
            end
            
            for i=1:length(handles.N(:,1))
                text(-handles.NodosDatos(handles.N(i,1),2),-handles.NodosDatos(handles.N(i,1),3),...
                    handles.NodosDatos(handles.N(i,1),4),[' \rightarrow','N',num2str(handles.N(i,1)),...
                    ' = ',num2str(round(handles.N(i,2),4)),' , ',num2str(round(handles.N(i,3),4)),...
                    ' , ',num2str(round(handles.N(i,4),4))],'color',[0 0 0],'FontSize',8,...
                    'FontWeight','bold','VerticalAlignment','top')
            end
            
            daspect([1 1 1])
            grid on
            hold off
            
        elseif gdes==1
            set(handles.listbox1,'Enable','on')
            for i=1:handles.No
                nodos{i}=i;
            end
            set(handles.listbox1,'String',nodos)
            
            hold on
            cla
            for i=1:handles.b
                %para x         para y          para z
                plot3(-handles.coodesp(:,1,i),-handles.coodesp(:,2,i),handles.coodesp(:,3,i),'-o',...
                    'color',[0.8 0 0.2],'LineWidth',1,'MarkerSize',5,'MarkerEdgeColor',...
                    [0.8 0 0.2],'MarkerFaceColor',[1 0.6 0.6])
            end
            
            i=get(handles.listbox1,'Value');
            for x=1:length(i)
                text(-handles.Nodosdesp(i(x),1),-handles.Nodosdesp(i(x),2),handles.Nodosdesp(i(x),3),...
                    [' \rightarrow','N',num2str(i(x)),' = ',num2str(round(handles.df(1,1,i(x)),...
                    4)),' , ',num2str(round(handles.df(1,2,i(x)),4)),' , ',num2str(round(handles.df(1,...
                    3,i(x)),4))],'color',[0 0 0],'FontSize',8,'FontWeight','bold',...
                    'VerticalAlignment','top')
            end
            daspect([1 1 1])
            grid on
            hold off
        end
    end
else
    set(handles.listbox1,'String','')
    slider1_Callback(hObject, [], handles);
end
guidata(hObject, handles);

% --- Executes on button press in VerResultados.
function VerResultados_Callback(~, ~, handles)
ResultadosGUI(handles.Estructura,handles.K0,handles.df,handles.N,handles.qf)

% --- Executes on button press in Mbarras.
function Mbarras_Callback(~, ~, handles)
MatricesBarrasGUI(handles.k,handles.b,handles.Estructura)

% --------------------------------------------------------------------
function Archivo_Callback(~, ~, ~)

% --------------------------------------------------------------------
function IExcel_Callback(hObject, ~, handles)
cla reset
if strcmp(handles.Estructura,'Ar2D')==1
    
    archivo='Armaduras.xlsx';
    NodosDatos=xlsread(archivo,-1);
    barrasnodos=xlsread(archivo,-1);
    b=length(barrasnodos(:,1));
    No=length(NodosDatos(:,1));
    
    set(handles.A,'Data',NodosDatos,'ColumnEditable',true,'ColumnName',...
        {'Nodo','Coordenada x','Coordenada y','Fuerza x','Fuerza y',...
        'Restriccion x','Restriccion y','Angulo Nodal','Kx','Ky'})
    set(handles.B,'Data',barrasnodos,'ColumnEditable',true,'ColumnName',...
        {'Barra','Nodo N','Nodo F','E','A','dL','alpha','dT'})
    set(handles.Nonodos,'String',No,'enable','inactive')
    set(handles.Nobarras,'String',b,'enable','inactive')

elseif strcmp(handles.Estructura,'Ar3D')==1
   
    archivo='Armaduras.xlsx';
    NodosDatos=xlsread(archivo,-1);
    barrasnodos=xlsread(archivo,-1);
    b=length(barrasnodos(:,1));
    No=length(NodosDatos(:,1));
    
    set(handles.A,'Data',NodosDatos,'ColumnEditable',true,'ColumnName',...
        {'Nodo','Coordenada x','Coordenada y','Coordenada z',...
        'Fuerza x','Fuerza y','Fuerza z','Restriccion x',...
        'Restriccion y','Restriccion z'})
    set(handles.B,'Data',barrasnodos,'ColumnEditable',true,'ColumnName',...
        {'Barra','Nodo N','Nodo F','E','A'})
    set(handles.Nonodos,'String',No,'enable','inactive')
    set(handles.Nobarras,'String',b,'enable','inactive')
   
end
guidata(hObject, handles);


% --------------------------------------------------------------------
function Herramientas_Callback(hObject, ~, handles)
if strcmp(get(hObject,'Checked'),'on')
    set(hObject,'Checked','off')
    set(handles.uitoolbar1,'visible','off')
else
    set(hObject,'Checked','on')
    set(handles.uitoolbar1,'visible','on')
end
guidata(hObject, handles);
